<?php
/**
 * @package		PaidSystem
 * @copyright	Copyright (C) 2010-2014 Juloa.com. All rights reserved.
 *  @license GNU General Public License version 3, or later
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_paidsystem'.DS.'tables');
jimport('joomla.application.component.controller');

/**
 * Content Component Controller
 *
 * @package		Joomla
 * @subpackage	Content
 * @since 1.5
 */
class PaidsystemControllerCategories extends TController
{
	var $_view = null;
	var $_model = null;
	
	function init()
	{
		// Set the default view name from the Request
		$this->_view = $this->getView("admin",'html');

		// Push a model into the view
		$this->_model = $this->getModel("category");
		try {
			$this->_view->setModel( $this->_model, true );
		} catch (Exception $e) {

		}
	}
	
	function display($cachable = false, $urlparams = false)
	{
		$this->canAccess();
		$this->init();
		$this->_view->setLayout("categories");
		$this->_view->display();
	}
	
	function save()
	{
		$this->canAccess();
		$app = JFactory::getApplication();

		$input = $app->input;
		$tid 		     = $input->get('tid', array(0), 'Array' );
		$total			 = count( $tid );
		$specific 		 = $input->get('specific', array(0), 'Array' );
		$price 			 = $input->get('price', array(0), 'Array' );
		$num_images	     = $input->get('num_images', array(0), 'Array' );
		$image_price     = $input->get('image_price', array(0), 'Array' );
		
		$model = $this->getModel("category");
		$model->updateCategories($tid,$total,$specific,$price,$num_images,$image_price);	
	
		$app->enqueueMessage(\JText::_('ADSMANAGER_CATEGORY_SAVED'), 'message');
		$app->redirect( 'index.php?option=com_paidsystem&c=categories', 200 );
	}

	private function canAccess() {
		$app = JFactory::getApplication();

		//check if the user can access the categories
		$user = JFactory::getUser();
		if(!$user->authorise('paidsystem.accesscategory','com_paidsystem')) {
			$app->enqueueMessage(\JText::_('JERROR_ALERTNOAUTHOR'), 'error');
			$app->redirect('index.php', 200);
		}

		return true;
	}
}