<?php
/**
 *  @package	PaidSystem
 *  @copyright	Copyright (C) 2010-2014 Juloa.com. All rights reserved.
 *  @license    GNU General Public License version 3, or later
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

if (version_compare(JVERSION,'1.6','>=')) {
    //ACL
    if (!JFactory::getUser()->authorise('core.manage', 'com_paidsystem')) {
        throw new Exception(JText::_('JERROR_ALERTNOAUTHOR'));
    }
}

require_once(JPATH_ROOT.'/components/com_adsmanager/lib/core.php');

if(!file_exists(JPATH_ROOT.'/components/com_invoicing/lib/core.php')){
    echo "You need to install the Invoicing component in order to use PaidSystem.";
    exit();
}

// Make sure the user is authorized to view this page
$user = JFactory::getUser();
if (version_compare(JVERSION,'1.6','>=')) {
    //ACL
    if (!JFactory::getUser()->authorise('core.manage', 'com_paidsystem')) {
        throw new Exception(JText::_('JERROR_ALERTNOAUTHOR'));
    }
}

// Component Helper
jimport('joomla.application.component.helper');

$input = JFactory::getApplication()->input;
$controllerName = $input->get( 'c', 'dashboard', 'cmd' );

require_once( JPATH_COMPONENT.DS.'controllers'.DS.$controllerName.'.php' );
$controllerName = 'PaidsystemController'.$controllerName;

// Create the controller
$controller = new $controllerName();

if(version_compare(JVERSION,'1.6.0','>=')){
	JHtml::_('jquery.framework');
}	

JHtmlSidebar::addEntry(JText::_('COM_PAIDSYSTEM_DASHBOARD'), 'index.php?option=com_paidsystem&amp;c=dashboard');
if($user->authorise('paidsystem.accessconfiguration','com_paidsystem')) {
    JHtmlSidebar::addEntry(JText::_('COM_PAIDSYSTEM_CONFIGURATION'), 'index.php?option=com_paidsystem&amp;c=configuration');
}
if($user->authorise('paidsystem.accesscategory','com_paidsystem')) {
    JHtmlSidebar::addEntry(JText::_('COM_PAIDSYSTEM_CATEGORIES'), 'index.php?option=com_paidsystem&amp;c=categories');
}
if($user->authorise('paidsystem.accessfield','com_paidsystem')) {
    JHtmlSidebar::addEntry(JText::_('COM_PAIDSYSTEM_FIELDS'), 'index.php?option=com_paidsystem&amp;c=fields');
}
if($user->authorise('paidsystem.accessduration','com_paidsystem')) {
    JHtmlSidebar::addEntry(JText::_('COM_PAIDSYSTEM_DURATIONS'), 'index.php?option=com_paidsystem&amp;c=durations');
}
if($user->authorise('paidsystem.accesstop','com_paidsystem')) {
    JHtmlSidebar::addEntry(JText::_('COM_PAIDSYSTEM_TOPS'), 'index.php?option=com_paidsystem&amp;c=tops');
}
if($user->authorise('paidsystem.accesshighlight','com_paidsystem')) {
    JHtmlSidebar::addEntry(JText::_('COM_PAIDSYSTEM_HIGHLIGHTS'), 'index.php?option=com_paidsystem&amp;c=highlights');
}
if($user->authorise('paidsystem.accessfeature','com_paidsystem')) {
    JHtmlSidebar::addEntry(JText::_('COM_PAIDSYSTEM_FEATUREDS'), 'index.php?option=com_paidsystem&amp;c=featureds');
}
		
// Perform the Request task
$controller->execute($input->get('task', null,'cmd'));
$controller->redirect();

// css
$document = JFactory::getApplication()->getDocument();
$document->addStyleSheet(JUri::base().'components/com_invoicing/css/admin_invoicing_panel.css');
