<?php
/**
 *  @package	PaidSystem
 *  @copyright	Copyright (C) 2010-2014 Juloa.com. All rights reserved.
 *  @license    GNU General Public License version 3, or later
 */
namespace Juloa\Paidsystem\Admin\Views\Admin\Tmpl;

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

include_once(JPATH_ROOT."/components/com_adsmanager/helpers/usergroups.php");
include_once(JPATH_ROOT.'/administrator/components/com_invoicing/helpers/select.php');

use Juloa\Adsmanager\Site\Helpers\JHTMLAdsmanagerUserGroups;

//echo JHTML::_('jquery.tooltip');
$editor	= \JEditor::getInstance();

$script = "
Joomla.submitbutton = function(pressbutton) {
	Joomla.submitform(pressbutton);
}
";

\JFactory::getApplication()->getDocument()->addScriptDeclaration($script);
?>
	<div id="overDiv" style="position:absolute; visibility:hidden; z-index:10000;"></div>
	<table class="adminheading table table-striped">
		<tr>
			<th class="config"><?php echo \JText::_('PAIDSYSTEM_ADMIN_CONFIG');?></th>
		</tr>
	</table>
	<form action="index.php" method="post" name="adminForm" id="adminForm">
    <?php
		$invoicingExist = file_exists(JPATH_ROOT.'/components/com_invoicing/lib/core.php');
		$virtualMoneyExist = file_exists(JPATH_ROOT.'/components/com_virtualmoney/Lib/core.php');
		
		if($invoicingExist || $virtualMoneyExist){
	?>
	<div>
		<?php
			if($invoicingExist && !$virtualMoneyExist) {
				if(!$this->InvoicingChechDataTransfert())
					echo "<a href='index.php?option=com_paidsystem&task=export_invoicing'>".\JText::_('PAIDSYSTEM_INVOICING_DATA_UPDATE')."</a>";
			} elseif(!$invoicingExist && $virtualMoneyExist) {
				if(!$this->VirtualMoneyChechDataTransfert())
					echo "<a href='index.php?option=com_paidsystem&task=export_virtualmoney'>".\JText::_('PAIDSYSTEM_VIRTUALMONEY_DATA_UPDATE')."</a>";
			} else {
				if(!$this->InvoicingChechDataTransfert() && !$this->VirtualMoneyChechDataTransfert())
					echo "<a href='index.php?option=com_paidsystem&task=export_all'>".\JText::_('PAIDSYSTEM_DATA_UPDATE')."</a>";
			}
		?>
	</div>
	<?php
		}
	?>
	<table cellpadding="4" cellspacing="1" border="0" width="100%" class="adminform table table-striped">
		<?php if(version_compare(JVERSION, '2.5', '>=')) {?>
		<tr>
			<td><?php echo \JText::_('CONFIG_DOWNLOADID_LABEL'); ?></td>
			<td>
                <input class="form-control" type="text" name="params_dlid" id="dlid" value="<?php echo @htmlspecialchars($this->conf->dlid)?>" />
            </td>
			<td><?php echo \JText::_('CONFIG_DOWNLOADID_DESC'); ?></td>
		</tr>
		<?php } ?>
		<tr>
			<td colspan='3'><strong><?php echo \JText::_('PAIDSYSTEM_MODE'); ?></strong></td>
		</tr>
		<tr>
			<td><?php echo \JText::_('PAIDSYSTEM_MODE'); ?></td>
			<td>
			<select class="form-select" id='mode' name='mode'>
				<option value='payperad' <?php if ($this->conf->mode == "payperad") { echo "selected"; } ?>><?php echo \JText::_('PAIDSYSTEM_MODE_PAYPERAD'); ?></option>
				<option value='credits' <?php if ($this->conf->mode == "credits") { echo "selected"; } ?>><?php echo \JText::_('PAIDSYSTEM_MODE_CREDITS'); ?></option>
			</select>
			</td>
			<td><?php echo \JText::_('PAIDSYSTEM_MODE_LONG'); ?></td>
		</tr>
		<tr class="payperad">
			<?php 
            if(file_exists(JPATH_ROOT.'/components/com_invoicing/lib/core.php')){
                include_once(JPATH_ROOT.'/components/com_invoicing/lib/core.php');
            }else{
                echo 'You need to install Invoicing.';exit();
            }
			?>
			<td><?php echo \JText::_('INVOICING_COMMON_CURRENCY'); ?></td>
			<td><?php echo \InvoicingHelperSelect::currencies('currency_id',$this->conf->currency_id,array('class'=>'form-select')) ?></td>
			<td></td>
		</tr>
		<tr class="payperad">
			<td><?php echo \JText::_('INVOICING_COMMON_TAX'); ?></td>
			<td><?php echo \InvoicingHelperSelect::taxes("tax",$this->conf->tax,array('class'=>'form-select')) ?></td>
			<td></td>
		</tr>
		<tr>
			<td colspan='3'><?php echo \JText::_('PAIDSYSTEM_CATEGORIES'); ?></td>
		</tr>
		<tr>
			<td><?php echo \JText::_('PAIDSYSTEM_CATCREDITS'); ?></td>
			<td><input class="form-control" type="text" name="credits" value="<?php echo $this->conf->credits; ?>" /></td>
			<td><?php echo \JText::_('PAIDSYSTEM_CATCREDITS_LONG'); ?></td>
		</tr>
		<tr>
			<td><?php echo \JText::_('PAIDSYSTEM_NBCATS'); ?></td>
			<td><input class="form-control" type="text" name="nbcats" value="<?php echo $this->conf->nbcats; ?>" /></td>
			<td><?php echo \JText::_('PAIDSYSTEM_NBCATS_LONG'); ?></td>
		</tr>
		<tr>
			<td><?php echo \JText::_('PAIDSYSTEM_CAT_PRICE'); ?></td>
			<td><input class="form-control" type="text" name="cat_price" value="<?php echo $this->conf->cat_price; ?>" /></td>
			<td><?php echo \JText::_('PAIDSYSTEM_CAT_PRICE_LONG'); ?></td>
		</tr>
		<tr>
			<td><?php echo \JText::_('PAIDSYSTEM_WITHOUT_PAGE_RELOAD'); ?></td>
			<td>
                <select class="form-select" name="params_without_page_reload" id="without_page_reload">
                    <option value='1' <?php if (@$this->conf->without_page_reload == 1) { echo "selected"; } ?>><?php echo \JText::_('Yes'); ?></option>
                    <option value='0' <?php if (@$this->conf->without_page_reload == 0) { echo "selected"; } ?>><?php echo \JText::_('No'); ?></option>
                </select>
            </td>
			<td><?php echo \JText::_('PAIDSYSTEM_WITHOUT_PAGE_RELOAD_LONG'); ?></td>
		</tr>
		<tr>
			<td colspan='3'><br/><b><?php echo  \JText::_('PAIDSYSTEM_OPTIONS'); ?></b></td>
		</tr>
		<tr>
			<td><?php echo  \JText::_('PAIDSYSTEM_FEATURED_ACTIVE'); ?></td>
			<td><?php echo $this->conf->featured_active; ?></td>
			<td><?php echo  \JText::_('PAIDSYSTEM_FEATURED_ACTIVE_LONG'); ?></td>
		</tr>
		<tr>
			<td><?php echo \JText::_('PAIDSYSTEM_HIGHLIGHT_ACTIVE'); ?></td>
			<td><?php echo $this->conf->highlight_active; ?></td>
			<td><?php echo \JText::_('PAIDSYSTEM_HIGHLIGHT_ACTIVE_LONG'); ?></td>
		</tr>
		<tr>
			<td><?php echo \JText::_('PAIDSYSTEM_TOP_ACTIVE'); ?></td>
			<td><?php echo $this->conf->top_active; ?></td>
			<td><?php echo \JText::_('PAIDSYSTEM_TOP_ACTIVE_LONG'); ?>	
			<input type="hidden" name="params_option_mode" value="duration" />
			</td>
		</tr>
        <?php /*?><tr>
			<td><?php echo \JText::_('PAIDSYSTEM_OPTION_MODE'); ?></td>
			<td>
                <select class="form-select" name="params_option_mode" id="option_mode">
                    <option value='duration' <?php if (@$this->conf->option_mode == 'duration') { echo "selected"; } ?>><?php echo \JText::_('PAIDSYSTEM_OPTION_MODE_DURATION'); ?></option>
                    <option value='interval' <?php if (@$this->conf->option_mode == 'interval') { echo "selected"; } ?>><?php echo \JText::_('PAIDSYSTEM_OPTION_MODE_INTERVAL'); ?></option>
                </select>
            </td>
			<td></td>
		</tr>
        <tr>
			<td><?php echo \JText::_('PAIDSYSTEM_FEATURED_PRICE_PER_DAY'); ?></td>
			<td>
			<input class="form-control" type="text" name="params_featured_price_per_day" value=<?php echo @$this->conf->featured_price_per_day; ?> />
			</td>
			<td></td>
		</tr>
        <tr>
			<td><?php echo \JText::_('PAIDSYSTEM_HIGHLIGHT_PRICE_PER_DAY'); ?></td>
			<td>
			<input class="form-control" type="text" name="params_highlight_price_per_day" value=<?php echo @$this->conf->highlight_price_per_day; ?> />
			</td>
			<td></td>
		</tr>
        <tr>
			<td><?php echo \JText::_('PAIDSYSTEM_TOP_PRICE_PER_DAY'); ?></td>
			<td>
			<input class="form-control" type="text" name="params_top_price_per_day" value=<?php echo @$this->conf->top_price_per_day; ?> />
			</td>
			<td></td>
		</tr>
        <tr>
			<td><?php echo \JText::_('PAIDSYSTEM_FEATURED_MAX_DAYS'); ?></td>
			<td>
			<input class="form-control" type="text" name="params_featured_max_days" value=<?php echo @$this->conf->featured_max_days; ?> />
			</td>
			<td></td>
		</tr>
        <tr>
			<td><?php echo \JText::_('PAIDSYSTEM_HIGHLIGHT_MAX_DAYS'); ?></td>
			<td>
			<input class="form-control" type="text" name="params_highlight_max_days" value=<?php echo @$this->conf->highlight_max_days; ?> />
			</td>
			<td></td>
		</tr>
        <tr>
			<td><?php echo \JText::_('PAIDSYSTEM_TOP_MAX_DAYS'); ?></td>
			<td>
			<input class="form-control" type="text" name="params_top_max_days" value=<?php echo @$this->conf->top_max_days; ?> />
			</td>
			<td></td>
		</tr>
		*/?>
        <tr>
			<td><?php echo \JText::_('PAIDSYSTEM_HIDE_TOTAL_PRICE'); ?></td>
			<td>
                <select class="form-select" name="params_hide_total_price" id="hide_total_price">
                    <option value='1' <?php if (@$this->conf->hide_total_price == 1) { echo "selected"; } ?>><?php echo \JText::_('Yes'); ?></option>
                    <option value='0' <?php if (@$this->conf->hide_total_price == 0) { echo "selected"; } ?>><?php echo \JText::_('No'); ?></option>
                </select>
            </td>
			<td>&nbsp;</td>
		</tr>
        <tr>
			<td><?php echo \JText::_('PAIDSYSTEM_HIDE_OPTION_TEXT'); ?></td>
			<td>
                <select class="form-select" name="params_hide_option_text" id="hide_option_text">
                    <option value='1' <?php if (@$this->conf->hide_option_text == 1) { echo "selected"; } ?>><?php echo \JText::_('Yes'); ?></option>
                    <option value='0' <?php if (@$this->conf->hide_option_text == 0) { echo "selected"; } ?>><?php echo \JText::_('No'); ?></option>
                </select>
            </td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td><?php echo \JText::_('PAIDSYSTEM_TOP_TYPE'); ?></td>
			<td>
			<select class="form-select" id='top_type' name='top_type'>
				<option value='1' <?php if ($this->conf->top_type == 1) { echo "selected"; } ?>><?php echo \JText::_('PAIDSYSTEM_TOP_TYPE_EVERYDAY'); ?></option>
				<option value='0' <?php if ($this->conf->top_type == 0) { echo "selected"; } ?>><?php echo \JText::_('PAIDSYSTEM_TOP_TYPE_ALWAYS'); ?></option>
			</select>
			</td>
			<td><?php echo \JText::_('PAIDSYSTEM_TOP_TYPE_LONG'); ?></td>
		</tr>
		<tr>
			<td><?php echo \JText::_('PAIDSYSTEM_MAIL_ON_NOTIFICATION_TOP'); ?></td>
			<td>
			<select class="form-select" id='mail_on_notification_top' name='params_mail_on_notification_top'>
				<option value='1' <?php if (@$this->conf->mail_on_notification_top == 1) { echo "selected"; } ?>><?php echo \JText::_('Yes'); ?></option>
				<option value='0' <?php if (@$this->conf->mail_on_notification_top == 0) { echo "selected"; } ?>><?php echo \JText::_('No'); ?></option>
			</select>
			</td>
			<td><?php echo \JText::_('PAIDSYSTEM_MAIL_ON_NOTIFICATION_TOP_LONG'); ?></td>
		</tr>
		<tr>
			<td><?php echo \JText::_('PAIDSYSTEM_MAIL_NOTIFICATION_TOP_SUBJECT'); ?></td>
			<td>
			<input class="form-control" type="text" name="params_mail_notification_top_subject" value="<?php echo @htmlspecialchars($this->conf->mail_notification_top_subject); ?>" />
			</td>
			<td></td>
		</tr>
		<tr>
			<td><?php echo \JText::_('PAIDSYSTEM_MAIL_NOTIFICATION_TOP_BODY'); ?></td>
			<td><?php echo $editor->display( 'params_mail_notification_top_body',  @$this->conf->mail_notification_top_body, '100%', '350', '75', '20' ); ?></td>
			<td></td>
		</tr>
        <tr>
            <td></td>
            <td><?php echo \JText::_('PAIDSYSTEM_POSSIBLE_TAGS')?></td>
            <td>&nbsp;</td>
        </tr>
        
		<tr>
			<td><?php echo \JText::_('PAIDSYSTEM_MAIL_ON_OPTION_EXPIRATION'); ?></td>
			<td>
			<select class="form-select" id='mail_on_option_expiration' name='params_mail_on_option_expiration'>
				<option value='1' <?php if (@$this->conf->mail_on_option_expiration == 1) { echo "selected"; } ?>><?php echo \JText::_('Yes'); ?></option>
				<option value='0' <?php if (@$this->conf->mail_on_option_expiration == 0) { echo "selected"; } ?>><?php echo \JText::_('No'); ?></option>
			</select>
			</td>
			<td></td>
		</tr>
		<tr>
			<td><?php echo \JText::_('PAIDSYSTEM_MAIL_EXPIRATION_SUBJECT'); ?></td>
			<td>
			<input class="form-control" type="text" name="params_mail_expiration_subject" value="<?php echo @htmlspecialchars($this->conf->mail_expiration_subject); ?>" />
			</td>
			<td></td>
		</tr>
		<tr>
			<td><?php echo \JText::_('PAIDSYSTEM_MAIL_EXPIRATION_BODY'); ?></td>
			<td><?php echo $editor->display( 'params_mail_expiration_body',  @$this->conf->mail_expiration_body, '100%', '350', '75', '20' ); ?></td>
			<td></td>
		</tr>
        <tr>
            <td></td>
            <td><?php echo \JText::_('PAIDSYSTEM_POSSIBLE_TAGS')?></td>
            <td>&nbsp;</td>
        </tr>
		<tr>
			<td colspan='3'><br/><b><?php echo \JText::_('PAIDSYSTEM_IMAGES'); ?></b></td>
		</tr>
		<tr>
			<td><?php echo \JText::_('PAIDSYSTEM_IMAGE_MODE'); ?></td>
			<td>
                <select class="form-select" name="params_enable_image_pack" id="enable_image_pack">
                    <option value='0' <?php if (@$this->conf->enable_image_pack == 0) { echo "selected"; } ?>><?php echo \JText::_('PAIDSYSTEM_IMAGES_MODE_IMAGE'); ?></option>
                    <option value='1' <?php if (@$this->conf->enable_image_pack == 1) { echo "selected"; } ?>><?php echo \JText::_('PAIDSYSTEM_IMAGES_MODE_PACK'); ?></option>
                </select>
            </td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td><?php echo \JText::_('PAIDSYSTEM_NUM_IMAGES'); ?></td>
			<td><input class="form-control" type="text" name="num_images" value=<?php echo $this->conf->num_images; ?> /></td>
			<td><?php echo \JText::_('PAIDSYSTEM_NUM_IMAGES_LONG'); ?></td>
		</tr>
		<tr>
			<td><?php echo \JText::_('PAIDSYSTEM_IMAGE_PRICE'); ?></td>
			<td><input class="form-control" type="text" name="image_price" value=<?php echo $this->conf->image_price; ?> /></td>
			<td><?php echo \JText::_('PAIDSYSTEM_IMAGE_PRICE_LONG'); ?></td>
		</tr>
        <?php if(version_compare(JVERSION, '1.6', 'ge')) { ?>
        <tr>
			<td colspan='3'><br/><b><?php echo \JText::_('PAIDSYSTEM_SPECIFIC_RIGHT'); ?></b></td>
		</tr>
        <tr>
			<td><?php echo \JText::_('PAIDSYSTEM_CATEGORIES_NOLIMIT'); ?></td>
			<td>
                <select class="form-select" name="params_categories_nolimit" id="categories_nolimit">
                    <option value='1' <?php if (@$this->conf->categories_nolimit == 1) { echo "selected"; } ?>><?php echo \JText::_('Yes'); ?></option>
                    <option value='0' <?php if (@$this->conf->categories_nolimit == 0) { echo "selected"; } ?>><?php echo \JText::_('No'); ?></option>
                </select>
                <?php
                    if(!empty($this->conf->usergroups_nolimit) && @$this->conf->usergroups_nolimit){
                        $userGroups = implode(',',$this->conf->usergroups_nolimit);
                    } else {
                        $userGroups = '';
                    }
                    
                    echo JHTMLAdsmanagerUserGroups::getUserGroups('params_usergroups_nolimit[]', empty($this->conf->usergroups_nolimit) ? '-1' : explode(',', $userGroups), array('multiple' => 'multiple', 'class' => 'form-select'));
                ?>
            </td>
			<td>&nbsp;</td>
		</tr>
		<tr>
			<td><?php echo \JText::_('PAIDSYSTEM_CATEGORIES_FREEADS'); ?></td>
			<td>
                <select class="form-select" name="params_categories_freeads" id="categories_freeads">
                    <option value='1' <?php if (@$this->conf->categories_freeads == 1) { echo "selected"; } ?>><?php echo \JText::_('Yes'); ?></option>
                    <option value='0' <?php if (@$this->conf->categories_freeads == 0) { echo "selected"; } ?>><?php echo \JText::_('No'); ?></option>
                </select>
                <?php
                    if(!empty($this->conf->usergroups_freeads) && @$this->conf->usergroups_freeads){
                        $userGroups = implode(',',$this->conf->usergroups_freeads);
                    } else {
                        $userGroups = '';
                    }
                    
                    echo JHTMLAdsmanagerUserGroups::getUserGroups('params_usergroups_freeads[]', empty($this->conf->usergroups_freeads) ? '-1' : explode(',', $userGroups), array('multiple' => 'multiple', 'class' => 'form-select'));
                ?>
            </td>
			<td>&nbsp;</td>
		</tr>
        <?php } ?>
  </table>
  <input type="hidden" name="id" value="<?php echo $this->conf->id;?>" />
  <input type="hidden" name="option" value="com_paidsystem" />
  <input type="hidden" name="task" value="" />
  <input type="hidden" name="c" value="configuration" />
</form>
<?php
	$script = "
		function updateMode() {
			if(jQ('#mode').val() == 'credits') {
				jQ('.payperad').hide();
			} else {
				jQ('.payperad').show();
			}
		}
		jQ('#mode').change(function() {
			updateMode();
		});
		updateMode();
	";

	\JFactory::getApplication()->getDocument()->addScriptDeclaration($script);
	