<?php
/**
 *  @package	PaidSystem
 *  @copyright	Copyright (C) 2010-2014 Juloa.com. All rights reserved.
 *  @license    GNU General Public License version 3, or later
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

include_once (JPATH_ROOT.'/components/com_adsmanager/helpers/usergroups.php');
?>
<form action="index.php" method="post" name="adminForm" id="adminForm" class="adminForm" enctype="multipart/form-data">
	
<div class="row">
	<div class="col">
	<div class="adminlist">
			<div class="mb-3 row">
				<div class="col col-3"><?php echo JText::_('PAIDSYSTEM_TH_NAME'); ?></div>
				<div class="col"><input class="form-control" type="text" size="50" maxsize="255" name="title" value="<?php echo htmlspecialchars($this->duration->title); ?>" /></div>
				
			</div>
			<div class="mb-3 row">
				<div class="col col-3"><?php echo JText::_('PAIDSYSTEM_DURATION_TYPE'); ?></div>
				<div class="col">
					<select class="form-select" name="type" id="type">
						<option value="both" <?php if ($this->duration->type == "both") { echo "selected"; } ?>><?php echo JText::_('PAIDSYSTEM_DURATION_TYPE_BOTH'); ?></option>
						<option value="renew" <?php if ($this->duration->type == "renew") { echo "selected"; } ?>><?php echo JText::_('PAIDSYSTEM_DURATION_TYPE_RENEW') ?></option>
						<option value="new" <?php if ($this->duration->type == "new") { echo "selected"; } ?>><?php echo JText::_('PAIDSYSTEM_DURATION_TYPE_NEW') ?></option>
					</select>
				</div>
				
			</div>
			<div class="mb-3 row">
				<div class="col col-3"><?php echo JText::_('PAIDSYSTEM_DURATION_LONG'); ?></div>
				<div class="col">
					<input class="form-control" type="text" id="duration" name="duration" value="<?php echo $this->duration->duration; ?>" />
				</div>
				<div class="col">
					<div class="form-check">
						<input class="form-check-input" type="checkbox" id="unlimited" <?php if ($this->duration->duration == 0) echo 'checked="checked"';?> />
						<label for="unlimited" class="form-check-label"><?php echo JText::_('PAIDSYSTEM_DURATION_UNLIMITED');?></label>
					</div>
				</div>
				
			</div>
			<div class="mb-3 row">
				<div class="col col-3"><?php echo JText::_('PAIDSYSTEM_PRICE'); ?></div>
				<div class="col"><input class="form-control" type="text"  name="credits" value="<?php echo $this->duration->credits; ?>" /></div>
				
			</div>
			<div class="mb-3 row">
				<div class="col col-3"><?php echo JText::_('PAIDSYSTEM_TH_PUBLISH'); ?></div>
				<div class="col">
					<select class="form-select" name="published" id="published">
						<option value="1" <?php if ($this->duration->published == 1) { echo "selected"; } ?>><?php echo JText::_('PAIDSYSTEM_PUBLISHED'); ?></option>
						<option value="0" <?php if ($this->duration->published == 0) { echo "selected"; } ?>><?php echo JText::_('PAIDSYSTEM_NOT_PUBLISHED') ?></option>
					</select>
				</div>
				
			</div>
            <div class="mb-3 row">
				<div class="col col-3"><?php echo JText::_('PAIDSYSTEM_TH_ACL'); ?></div>
				<div class="col">
					<?php
                        echo \Juloa\Adsmanager\Site\Helpers\JHTMLAdsmanagerUserGroups::getUserGroups('params_acl[]', empty($this->duration->acl) ? '-1' : explode(',', $this->duration->acl), array('multiple' => 'multiple', 'class' => 'form-select'));
                    ?>
				</div>
				
			</div>
		</div>
	</div>

	<div class="col col-1"></div>

	<div class="col">
		<div class="adminform row">
			<div class="col col-3">
				<label><?php echo JText::_('ADSMANAGER_FORM_CATEGORY'); ?></label>	
			</div>
			<div class="col">
				<select class="form-select" name="field_catsid[]" multiple='multiple' id="field_catsid[]" size="10">
					<?php 
					if (strpos($this->duration->catsid, ",-1,") === false)
						echo "<option value='-1'>".JText::_('ADSMANAGER_MENU_ALL_ADS')."</option>";
					else
						echo "<option value='-1' selected>".JText::_('ADSMANAGER_MENU_ALL_ADS')."</option>";
					
					$this->selectCategories(0,"",$this->cats,-1,-1,1,$this->duration->catsid);
					?>
				</select>
			</div>	
		</div>
	</div>
</div>

	

	<input type="hidden" name="id" value="<?php echo $this->duration->id; ?>" />
	<input type="hidden" name="option" value="com_paidsystem" />
	<input type="hidden" name="c" value="durations" />
	<input type="hidden" name="task" value="" />
	</form>
	<?php
		$script = "
			previousval = jQ('#duration').val();
			function checkUnlimited() {
				if (jQ('#unlimited').is(':checked')) {
					previousval = jQ('#duration').val();
					jQ('#duration').val(0);
					jQ('#duration').attr('readonly','readonly');
				} else {
					jQ('#duration').val(previousval);
					jQ('#duration').removeAttr('readonly');
				}
			}
			jQ('#unlimited').change(function() { checkUnlimited(); });
			checkUnlimited();
		";

		JFactory::getApplication()->getDocument()->addScriptDeclaration($script);
