<?php
/**
 *  @package	PaidSystem
 *  @copyright	Copyright (C) 2010-2014 Juloa.com. All rights reserved.
 *  @license    GNU General Public License version 3, or later
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

use Joomla\String\StringHelper as JString;
use Joomla\Utilities\ArrayHelper as JArrayHelper;

jimport('joomla.application.component.view');
jimport('joomla.html.pane');

require_once(JPATH_ROOT."/components/com_adsmanager/helpers/field.php");

?>
<style>
.icon-48-paidsystem {
	background-image: url('../components/com_paidsystem/images/logo.png');
	height: 48px;
}
</style>
<?php 

/**
 * @package		Joomla
 * @subpackage	Contacts
 */
class PaidsystemViewAdmin extends TView
{
	function __construct($config = array())
	{
		parent::__construct($config);
		
		$uri = JUri::getInstance();
		$baseurl = JURI::base();
		$baseurl = str_replace("administrator/","",$baseurl);
		
		$user		= JFactory::getUser();
		
		$this->userid = $user->id;
		$this->baseurl = $baseurl;
		$this->baseurl = $baseurl;
		
		if(version_compare(JVERSION, '3.0', 'ge')) {
			$js = "checkAll = Joomla.checkAll;";
			$js .= "isChecked = Joomla.isChecked;";
			$doc = JFactory::getDocument();
			$doc->addScriptDeclaration($js);
		}
	}
	
	function display($tpl = null)
	{
		$subfunction = "_".$this->_layout;
		
		$this->$subfunction();
		
		parent::display();
	}
	
	function setListToolbar($title)
	{
		JToolBarHelper::title( $title, 'paidsystem' );
		JToolBarHelper::editList();
		JToolBarHelper::addNew();
		JToolBarHelper::deleteList();
        $bar =  JToolBar::getInstance('toolbar');
		$label = 'JTOOLBAR_HELP';
		$bar->appendButton( 'Link', 'help', $label, JRoute::_('index.php?option=com_paidsystem&c=doc') );
	
        if (version_compare(JVERSION,'1.6','>=')) {
            // Options button.
            if (JFactory::getUser()->authorise('core.admin', 'com_paidsystem')) {
                JToolBarHelper::preferences('com_paidsystem');
            }
        }
    }
	
	function setEditToolbar($title)
	{
		JToolBarHelper::title( $title, 'paidsystem' );
		JToolBarHelper::apply();
		JToolBarHelper::save();
		if (!version_compare(JVERSION,'1.7.0','<')) {
            JToolBarHelper::save2new();
        }
		JToolBarHelper::cancel();
        $bar =  JToolBar::getInstance('toolbar');
		$label = 'JTOOLBAR_HELP';
		$bar->appendButton( 'Link', 'help', $label, JRoute::_('index.php?option=com_paidsystem&c=doc') );
		
        if (version_compare(JVERSION,'1.6','>=')) {
            // Options button.
            if (JFactory::getUser()->authorise('core.admin', 'com_adsmanager')) {
                JToolBarHelper::preferences('com_adsmanager');
            }
        }
    }
	
	function setViewToolbar($title)
	{
		JToolBarHelper::title( $title, 'paidsystem' );
		JToolBarHelper::save();
        $bar = JToolBar::getInstance('toolbar');
		$label = 'JTOOLBAR_HELP';
		$bar->appendButton( 'Link', 'help', $label, JRoute::_('index.php?option=com_paidsystem&c=doc') );
	}
	
	function _mosTreeRecurse( $id, $indent, $list, &$children, $maxlevel=9999, $level=0, $type=1,$parent='parent') {
		if (@$children[$id] AND $level <= $maxlevel) {
			$newindent = $indent.($type ? '.&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' : '&nbsp;&nbsp;');
			$pre = $type ? '<sup>L</sup>&nbsp;' : '- ';
			foreach ($children[$id] as $v) {
				$id = $v->id;
				$list[$id] = $v;
				$list[$id]->treename = $indent.($v->$parent == 0 ? '' : $pre).$v->name;
				if(isset($children[$id]) && $children[$id] != NULL) {
					$list[$id]->children = count( @$children[$id] );
				} else {
					$list[$id]->children = 0;
				}
				$list[$id]->level = $level;
				$list = $this->_mosTreeRecurse( $id, $newindent, $list, $children, $maxlevel, $level+1, $type );
			}
		}
		return $list;
	}
	
	
	function _categories()
	{
		$app = JFactory::getApplication();
		
		$this->setViewToolbar("PaidSystem - ".JTEXT::_("Categories"));
		
		$input = JFactory::getApplication()->input;
		$search = JString::trim( $input->get( 'search', '', 'String' ));
		$limit	= $app->getUserStateFromRequest('global.list.limit',									'limit',			$app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest("com_adsmanager.admin_category.limitstart",			'limitstart',		0,			'int');
		
		$model = $this->getModel();
		$total = $model->getNbCats($search);
		
		jimport('joomla.html.pagination');
		$pagination = new JPagination($total, $limitstart, $limit);
		
		$rows = $model->getCategories($search,$limitstart,$limit);
		
		// establish the hierarchy of the menu
		$children = array();
		// first pass - collect children
		if (isset($rows)) {
			foreach ($rows as $v ) {
				$pt 	= $v->parent;
				$list 	= @$children[$pt] ? $children[$pt] : array();
				array_push( $list, $v );
				$children[$pt] = $list;
			}
		}
		// second pass - get an indent list of the items
		$list = $this->_mosTreeRecurse( 0, '', array(), $children);
		$list = array_slice( $list, $pagination->limitstart, $pagination->limit );
		
		$ordering = 1;
		$this->search = $search;
		$this->ordering = $ordering;
		$this->list = $list;
		$this->pagination = $pagination;
		$this->total = $total;
	}
	
	function _fields()
	{
		$app = JFactory::getApplication();
		
		$this->setViewToolbar("PaidSystem - ".JTEXT::_("PAIDSYSTEM_FIELDS"));
		
		$limit	= $app->getUserStateFromRequest('global.list.limit',									'limit',			$app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest("com_adsmanager.admin_field.limitstart",			'limitstart',		0,			'int');
		
		$model = $this->getModel();
		$total = $model->getNbFields();
		
		jimport('joomla.html.pagination');
		$pagination = new JPagination($total, $limitstart, $limit);
		
		$rows = $model->getFields($limitstart,$limit);

		$this->rows = $rows;
		$this->pagination = $pagination;
		$this->total = $total;
	}
	
	function _editpack()
	{		
		$this->setEditToolbar("PaidSystem - ".JTEXT::_("Pack"));
		
		$input = JFactory::getApplication()->input;
		$id = $input->get( 'tid', array(0), 'array');
		if (is_array($id))
			$id = $id[0];

		$pack = JTable::getInstance('pack', 'PaidsystemTable');
		$pack->load($id);
		
		$this->pack = $pack;
	}
	
	function _packs()
	{
		$app = JFactory::getApplication();
		
		$this->setListToolbar("PaidSystem - ".JTEXT::_("PAIDSYSTEM_PACKAGES"));
		
		$input = JFactory::getApplication()->input;
		$search = JString::trim( $input->get( 'search', '', 'String' ) );
		$limit	= $app->getUserStateFromRequest('global.list.limit',									'limit',			$app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest("com_paidsystem.admin_pack.limitstart",			'limitstart',		0,			'int');
		
		$model = $this->getModel();
		$total = $model->getNbPacks($search);
		
		jimport('joomla.html.pagination');
		$pagination = new JPagination($total, $limitstart, $limit);
		
		$rows = $model->getPacks($search,$limitstart,$limit);

		$this->search = $search;
		$this->rows = $rows;
		$this->pagination = $pagination;
		$this->total = $total;
	}
	
	function _durations()
	{
		$app = JFactory::getApplication();
		
		$this->setListToolbar("PaidSystem - ".JTEXT::_("PAIDSYSTEM_DURATIONS"));
		
		$input = JFactory::getApplication()->input;
		$search = JString::trim( $input->get( 'search', '', 'String' ) );
		$limit	= $app->getUserStateFromRequest('global.list.limit',									'limit',			$app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest("com_paidsystem.admin_duration.limitstart",			'limitstart',		0,			'int');
		
		$model = $this->getModel();
		$total = $model->getNbDurations($search);
		
		jimport('joomla.html.pagination');
		$pagination = new JPagination($total, $limitstart, $limit);
		
		$rows = $model->getDurations($search,$limitstart,$limit);
		
		$this->search = $search;
		$this->rows = $rows;
		$this->pagination = $pagination;
		$this->total = $total;
	}
	
	function _tops()
	{
		$app = JFactory::getApplication();
		
		$this->setListToolbar("PaidSystem - ".JTEXT::_("PAIDSYSTEM_TOPS"));
		
		$input = JFactory::getApplication()->input;
		$search = JString::trim( $input->get( 'search', '', 'String' ) );
		$limit	= $app->getUserStateFromRequest('global.list.limit',									'limit',			$app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest("com_paidsystem.admin_duration.limitstart",			'limitstart',		0,			'int');
		
		$model = $this->getModel();
		$total = $model->getNbTops($search);
		
		jimport('joomla.html.pagination');
		$pagination = new JPagination($total, $limitstart, $limit);
		
		$rows = $model->getTops($search,$limitstart,$limit);
		
		$this->search = $search;
		$this->rows = $rows;
		$this->pagination = $pagination;
		$this->total = $total;
	}
	
	function _featureds()
	{
		$app = JFactory::getApplication();
		
		$this->setListToolbar("PaidSystem - ".JTEXT::_("PAIDSYSTEM_FEATUREDS"));
		
		$input = JFactory::getApplication()->input;
		$search = JString::trim( $input->get( 'search', '', 'String' ) );
		$limit	= $app->getUserStateFromRequest('global.list.limit',									'limit',			$app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest("com_paidsystem.admin_duration.limitstart",			'limitstart',		0,			'int');
		
		$model = $this->getModel();
		$total = $model->getNbFeatureds($search);
		
		jimport('joomla.html.pagination');
		$pagination = new JPagination($total, $limitstart, $limit);
		
		$rows = $model->getFeatureds($search,$limitstart,$limit);
		
		$this->search = $search;
		$this->rows = $rows;
		$this->pagination = $pagination;
		$this->total = $total;
	}
	
	function _coupons()
	{
		$app = JFactory::getApplication();
		
		$this->setListToolbar("PaidSystem - ".JTEXT::_("COM_PAIDSYSTEM_COUPONS"));
		
		$input = JFactory::getApplication()->input;
		$search = JString::trim( $input->get( 'search', '', 'String' ) );
		$limit	= $app->getUserStateFromRequest('global.list.limit',									'limit',			$app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest("com_paidsystem.admin_duration.limitstart",			'limitstart',		0,			'int');
		
		$model = $this->getModel();
		$total = $model->getNbCoupons($search);
		
		jimport('joomla.html.pagination');
		$pagination = new JPagination($total, $limitstart, $limit);
		
		$rows = $model->getCoupons($search,$limitstart,$limit);
		
		$this->search = $search;
		$this->rows = $rows;
		$this->pagination = $pagination;
		$this->total = $total;
	}
	
	function _highlights()
	{
		$app = JFactory::getApplication();
		
		$this->setListToolbar("PaidSystem - ".JTEXT::_("PAIDSYSTEM_HIGHLIGHTS"));
		
		$input = JFactory::getApplication()->input;
		$search = JString::trim( $input->get( 'search', '', 'String' ) );
		$limit	= $app->getUserStateFromRequest('global.list.limit',									'limit',			$app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest("com_paidsystem.admin_duration.limitstart",			'limitstart',		0,			'int');
		
		$model = $this->getModel();
		$total = $model->getNbHighlights($search);
		
		jimport('joomla.html.pagination');
		$pagination = new JPagination($total, $limitstart, $limit);
		
		$rows = $model->getHighlights($search,$limitstart,$limit);
		
		$this->search = $search;
		$this->rows = $rows;
		$this->pagination = $pagination;
		$this->total = $total;
	}
	
	function _order()
	{
		$app = JFactory::getApplication();
		
		$this->setEditToolbar("PaidSystem - ".JTEXT::_("COM_PAIDSYSTEM_ORDERS"));
		
		$input = JFactory::getApplication()->input;
		$id = $input->get( 'tid', array(0), 'array');
		if (is_array($id))
			$id = $id[0];

		$order = JTable::getInstance('order', 'Table');
		$order->load($id);
		$this->order = $order;
	}
	
	function _history()
	{
		$app = JFactory::getApplication();
		$filters = array();
		
		JToolBarHelper::title( "PaidSystem - ".JTEXT::_("COM_PAIDSYSTEM_HISTORY"), 'paidsystem' );
		
		$limit	= $app->getUserStateFromRequest('global.list.limit',									'limit',			$app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest("com_paidsystem.admin_duration.limitstart",			'limitstart',		0,			'int');
		$search = $app->getUserStateFromRequest( 'com_paidsystem.history.user','search', '','word' );
		if ($search != "") {
			$filters['username'] = $search;
		}
		$this->search = $search;
		
		$model = $this->getModel();
		$total = $model->getNbEvents($filters);
		
		jimport('joomla.html.pagination');
		$pagination = new JPagination($total, $limitstart, $limit);
		$rows = $model->getEvents($limitstart,$limit,$filters);
		
		$this->rows = $rows;
		$this->pagination = $pagination;
		$this->total = $total;
	}
	
	function _orders()
	{
		$app = JFactory::getApplication();
		$filters = array();
		
		JToolBarHelper::title( "PaidSystem - ".JTEXT::_("COM_PAIDSYSTEM_ORDERS"), 'paidsystem' );
		
		$limit	= $app->getUserStateFromRequest('global.list.limit',									'limit',			$app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest("com_paidsystem.admin_duration.limitstart",			'limitstart',		0,			'int');
		$state = $app->getUserStateFromRequest( 'com_paidsystem.orders.state','filterstate', '','word' );
		$search = $app->getUserStateFromRequest( 'com_paidsystem.orders.user','search', '','word' );
		if ($search != "") {
			$filters['username'] = $search;
		}
		$this->search = $search;
		if ($state != "") {
			$filters['state'] = $state;
		}
		$this->filterstate = $state;
		
		$model = $this->getModel();
		$total = $model->getNbOrders($filters);
		
		jimport('joomla.html.pagination');
		$pagination = new JPagination($total, $limitstart, $limit);
		$rows = $model->getOrders($limitstart,$limit,$filters);
		
		$this->rows = $rows;
		$this->pagination = $pagination;
		$this->total = $total;
	}
	
	function _editduration()
	{
		$app = JFactory::getApplication();
		
		$this->setEditToolbar("PaidSystem - ".JTEXT::_("Duration"));
		
		$input = JFactory::getApplication()->input;
		$id = $input->get( 'tid', array(0), 'array');
		if (is_array($id))
			$id = $id[0];

		$duration = JTable::getInstance('duration', 'PaidsystemTable');
		$duration->load($id);
		
		$model = $this->getModel();
		$cats = $model->getCats(false);
		
		$this->cats = $cats;
		$this->duration = $duration;
	}
	
	function _edithighlight()
	{
		$app = JFactory::getApplication();
		
		$this->setEditToolbar("PaidSystem - ".JTEXT::_("PAIDSYSTEM_HIGHLIGHT"));
		
		$input = JFactory::getApplication()->input;
		$id = $input->get( 'tid', array(0), 'array');
		if (is_array($id))
			$id = $id[0];

		$duration = JTable::getInstance('highlight', 'PaidsystemTable');
		$duration->load($id);
		
		$model = $this->getModel();
		$cats = $model->getCats(false);
		
		$this->cats = $cats;
		$this->highlight = $duration;
	}
	
	function _edittop()
	{
		$app = JFactory::getApplication();
		
		$this->setEditToolbar("PaidSystem - ".JTEXT::_("PAIDSYSTEM_TOP"));
		
		$input = JFactory::getApplication()->input;
		$id = $input->get( 'tid', array(0), 'array');
		if (is_array($id))
			$id = $id[0];

		$duration = JTable::getInstance('top', 'PaidsystemTable');
		$duration->load($id);
		
		$model = $this->getModel();
		$cats = $model->getCats(false);
		
		$this->cats = $cats;
		$this->top = $duration;
	}
	
	function _editfeatured()
	{
		$app = JFactory::getApplication();
		
		$this->setEditToolbar("PaidSystem - ".JTEXT::_("PAIDSYSTEM_FEATURED"));
		
		$input = JFactory::getApplication()->input;
		$id = $input->get( 'tid', array(0), 'array');
		if (is_array($id))
			$id = $id[0];

		$duration = JTable::getInstance('featured', 'PaidsystemTable');
		$duration->load($id);
		
		$model = $this->getModel();
		$cats = $model->getCats(false);
		
		$this->cats = $cats;
		$this->featured = $duration;
	}
	
	function _editcoupon()
	{
		$app = JFactory::getApplication();
		
		$this->setEditToolbar("PaidSystem - ".JTEXT::_("COM_PAIDSYSTEM_COUPONS"));
		
		$input = JFactory::getApplication()->input;
		$id = $input->get( 'tid', array(0), 'array');
		if (is_array($id))
			$id = $id[0];

		$coupon = JTable::getInstance('coupon', 'PaidsystemTable');
		$coupon->load($id);
		$coupon->itemtype = explode(',',$coupon->itemtype);
		
		if ($coupon->hitslimit == 0) {
			$coupon->hitslimit = "";
		}
		if ($coupon->userhitslimit == 0) {
			$coupon->userhitslimit = "";
		}
		
		$this->coupon = $coupon;
	}
	
	function _users()
	{
		$app = JFactory::getApplication();
		
		$this->setListToolbar("PaidSystem - ".JTEXT::_("PAIDSYSTEM_USERS"));
		
		$input = JFactory::getApplication()->input;
		$search = JString::trim( $input->get( 'search', '', 'String' ));
		$limit	= $app->getUserStateFromRequest('global.list.limit',									'limit',			$app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest("com_paidsystem.admin_user.limitstart",			'limitstart',		0,			'int');
		
		$model = $this->getModel();
		$total = $model->getNbUsers($search);
		
		jimport('joomla.html.pagination');
		$pagination = new JPagination($total, $limitstart, $limit);
		
		$rows = $model->getUsers($search,$limitstart,$limit);

		$this->search = $search;
		$this->rows = $rows;
		$this->pagination = $pagination;
		$this->total = $total;
	}
	
	function _edituser()
	{
		$app = JFactory::getApplication();
		
		$this->setEditToolbar("PaidSystem - ".JTEXT::_("Users"));
		
		$input = JFactory::getApplication()->input;
		$id = $input->get( 'cid', array(0), 'array');
		if (is_array($id))
			$id = $id[0];

		$model = $this->getModel();	
		if ($id == 0)
		{
			$allusers = $model->getUsersWithoutCredits();
			$users = JHTML::_('select.genericlist', $allusers, 'userid', 'class="form-control" size="1"', 'value', 'text' );
		
			$this->allusers = $users;
		}
		else
		{
			// load the row from the db table
			$user = $model->getUserCreditsById($id);
			$this->user = $user;
		}
	}
	
	function _log()
	{
		JToolBarHelper::title( "PaidSystem - ".JTEXT::_("PAIDSYSTEM_LOG"), 'paidsystem' );
		$config = JFactory::getConfig();
		if(version_compare(JVERSION, '3.0', 'ge')) {
			$logpath = $config->get('log_path');
		} else {
			$logpath = $config->getValue('log_path');
		}
    
		$logFilenameBase = $logpath.'/paidsystem';
		$logFile = $logFilenameBase.'.php';
        $logData = "";
        if (file_exists($logFile)) {
            $logData = file_get_contents($logFile);
            $logData = str_replace("<?php die(); ?>","",$logData);
            $logData = str_replace("\n","<br/>",$logData);
        }
		$this->log = $logData;
	}
	
	function _editcategory()
	{
		$this->setEditToolbar("PaidSystem - ".JTEXT::_("Edit Category"));
		
		$input = JFactory::getApplication()->input;
		$catid = $input->get( 'cids', array(0), 'array' );
		JArrayHelper::toInteger($catid, array(0));
		$id	= $input->get( 'id', $catid[0], 'int' );

		$model = $this->getModel();
		
		$cat = $model->getCategory($id);
						 
		$cats = $model->getCatTree(false);
		$this->cats = $cats;
		
		$this->row = $cat;

	}
	
	function _configuration()
	{
        /*$db = JFactory::getDBO();
        
        $query = "RENAME TABLE #__paidsystem_credits_old TO #__paidsystem_credits";
		$db->setQuery($query);
		$db->execute();
        
        $query = "RENAME TABLE #__paidsystem_pack_old TO #__paidsystem_pack";
		$db->setQuery($query);
		$db->execute();
        
        $query = "RENAME TABLE #__paidsystem_coupons_old to #__paidsystem_coupons";
		$db->setQuery($query);
		$db->execute();
        
        $query = "RENAME TABLE #__paidsystem_orders_old TO #__paidsystem_orders";
		$db->setQuery($query);
		$db->execute();*/
        
		$this->setViewToolbar("PaidSystem - ".JTEXT::_("Configuration"));
		
		$model = $this->getModel();
		$conf  = $model->getConfiguration();
		$conf->highlight_active = JHTML::_('select.booleanlist', 'highlight_active', 'class="form-control"', $conf->highlight_active );
		$conf->featured_active = JHTML::_( 'select.booleanlist','featured_active', 'class="form-control"', $conf->featured_active );
		$conf->top_active = JHTML::_( 'select.booleanlist','top_active', 'class="form-control"', $conf->top_active );
		
        $this->conf = $conf;
	}
	
    function InvoicingChechDataTransfert() {
		$db = JFactory::getDBO();
		
		$tableList = $db->getTableList();
		$prefix = $db->getPrefix();
		
		if(array_search($prefix.'paidsystem_orders', $tableList) === false) {
			return true;
		}
		
		return false;
	}
	
	function VirtualMoneyChechDataTransfert() {
		$db = JFactory::getDBO();
		
		$tableList = $db->getTableList();
		$prefix = $db->getPrefix();
		
		if(array_search($prefix.'paidsystem_pack', $tableList) === false) {
			return true;
		}
		
		return false;
	}
    
	function selectCategories($id, $level, $children,$catid,$nodisplaycatid,$multiple=0,$catsid="") {
		if (@$children[$id]) {
			foreach ($children[$id] as $row) {
				if ($row->id != $nodisplaycatid) {
					if ((($multiple == 0)&&($row->id != $catid))
					    ||
					    (($multiple == 1)&&(strpos($catsid, ",$row->id,") === false)))
						echo "<option value='".$row->id."'>".$level.$row->name."</option>";
					else
						echo "<option value='".$row->id."' selected>".$level.$row->name."</option>";
					
					$this->selectCategories($row->id, $level.$row->name." >> ", $children,$catid,$nodisplaycatid,$multiple,$catsid);
				}
			}
		}
	}

	function _dashboard()
    {
    	$app = JFactory::getApplication();
    
    	$this->setListToolbar(JText::_("COM_PAIDSYSTEM")." - ".JText::_("PAIDSYSTEM_DASHBOARD"));
    
    	$model = $this->getModel();
    	 
    	 
    }
}