<?php
/**
 *  @package	PaidSystem
 *  @copyright	Copyright (C) 2010-2014 Juloa.com. All rights reserved.
 *  @license    GNU General Public License version 3, or later
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

$lang = JFactory::getLanguage();
$lang->load("com_paidsystem",JPATH_ROOT);


function getBalance($userId) {
    if(file_exists(JPATH_ROOT.'/components/com_virtualmoney/lib/core.php')) {
        include_once(JPATH_ROOT.'/components/com_virtualmoney/lib/core.php');
    } else {
        cleanError('You need to install VirtualMoney.');
    }
				
    return Virtualmoney::getCredits($userId,false,true);
}

function checkCredits($total, $userId) {
    if(file_exists(JPATH_ROOT.'/components/com_virtualmoney/lib/core.php')) {
        include_once(JPATH_ROOT.'/components/com_virtualmoney/lib/core.php');
    } else {
        cleanError('You need to install VirtualMoney.');
    }
				
    return Virtualmoney::checkCredits($total,$userId);
}

function removeCredits($userId, $newCredits, $items, $source = '') {
    if(file_exists(JPATH_ROOT.'/components/com_virtualmoney/lib/core.php')) {
        include_once(JPATH_ROOT.'/components/com_virtualmoney/lib/core.php');
    } else {
        cleanError('You need to install VirtualMoney.');
    }
    include_once(JPATH_ROOT.'/administrator/components/com_virtualmoney/helpers/cparams.php');
    include_once(JPATH_ROOT.'/administrator/components/com_virtualmoney/helpers/format.php');
    
    $description = JText::_('VIRTUALMONEY_BUY_AD')."\n";
    foreach($items as $item) {
        $description .= " - ".$item['description']." (".VirtualmoneyHelperFormat::formatPrice($item['gross_unit_price']).")\n";
    }
    
    return Virtualmoney::removeCredits($userId,$newCredits,$description,$source);
}

function linkTransactionToContent($transactionId, $contentId) {
    Virtualmoney::linkTransactionToContent($transactionId,$contentId);
}

function getPrice($price,$prefix="") {
	if ($price == 0)
		return "";
	
    $conf = getPaidSystemConfig();
    $mode = $conf->mode;
    
    if($mode == "payperad"){
        if(file_exists(JPATH_ROOT.'/components/com_invoicing/lib/core.php')) {
            include_once(JPATH_ROOT.'/components/com_invoicing/lib/core.php');
        }else{
            cleanError('You need to install Invoicing.');
        }
        
        $currency = Invoicing::getCurrencies($conf->currency_id);
        
        return $prefix.Invoicing::formatPrice($price, $currency);
    } else {
        include_once(JPATH_ROOT.'/administrator/components/com_virtualmoney/helpers/cparams.php');
        include_once(JPATH_ROOT.'/administrator/components/com_virtualmoney/helpers/format.php');
        
        return $prefix.VirtualmoneyHelperFormat::formatPrice($price);
    }
}

function getCurrencySymbol($type="code") {
	static $mode = null;
	static $currency = null;
	
	if ($mode == null) {
		$conf = getPaidSystemConfig();
		$mode = $conf->mode;
	}

	if ($mode == "payperad") {
		if(file_exists(JPATH_ROOT.'/components/com_invoicing/lib/core.php')) {
            include_once(JPATH_ROOT.'/components/com_invoicing/lib/core.php');
        }else{
            cleanError('You need to install Invoicing.');
        }
        
        $currency = Invoicing::getCurrencies($conf->currency_id);
        
        if ($type == "code") {
        	return $currency->code;
        } else {
        	return $currency->symbol;
        }
    } else {
        include_once(JPATH_ROOT.'/administrator/components/com_virtualmoney/helpers/format.php');
        include_once(JPATH_ROOT.'/administrator/components/com_virtualmoney/helpers/cparams.php');
		return VirtualmoneyHelperFormat::getConfigFormatCurrency()->codePlural;
    }
}

function getCurrencyPosition() {
	static $mode = null;
	static $currency = null;
	
	if ($mode == null) {
		$conf = getPaidSystemConfig();
		$mode = $conf->mode;
	}

	if ($mode == "payperad") {
		if(file_exists(JPATH_ROOT.'/components/com_invoicing/lib/core.php')) {
            include_once(JPATH_ROOT.'/components/com_invoicing/lib/core.php');
        }else{
            cleanError('You need to install Invoicing.');
        }
        
        $currency = Invoicing::getCurrencies($conf->currency_id);
        
        return $currency->symbol_position;
    } else {
        include_once(JPATH_ROOT.'/administrator/components/com_virtualmoney/helpers/format.php');
        include_once(JPATH_ROOT.'/administrator/components/com_virtualmoney/helpers/cparams.php');
		return VirtualmoneyHelperFormat::getConfigFormatCurrency()->position;
    }
}

function savePaidAd($content,$contentid) {
	$db = JFactory::getDbo();
	
	$conf = getPaidSystemConfig();
	
	if ($contentid != 0) {
		$db->setQuery("SELECT * FROM #__paidsystem_ads WHERE id = ".(int)$contentid);
		$row = $db->loadObject();
		if ($row == null) {
			$row = new JObject();
			$row->id = $contentid;
		}
	} else {
		$row = new JObject();
		$row->id = $contentid;
		$row->highlight = 0;
		$row->featured = 0;
		$row->top = 0;
		$row->images = 0;
	}
	
	$app = JFactory::getApplication();
	$input = JFactory::getApplication()->input;
	$option = $input->get('option','', 'String');
	if ($option == "com_adsmanager" && $app->isClient('administrator') == true) {
		$row->highlight = $content->data['paid']['highlight'];
		$row->highlight_up = $content->data['paid']['highlight_up'];
		$row->highlight_down = $content->data['paid']['highlight_down'];
		$row->featured = $content->data['paid']['featured'];
		$row->featured_up = $content->data['paid']['featured_up'];
		$row->featured_down = $content->data['paid']['featured_down'];
		$row->top = $content->data['paid']['top'];
		$row->top_up = $content->data['paid']['top_up'];
		$row->top_down = $content->data['paid']['top_down'];

		$row->images = $content->data['paid']['images_pack'];
	} else {
        if (@$content->data['paid']['images_pack'] != 0) {
            $row->images = 1;
		}

		if ((isset($pending->data->duration))) {
			$ad_duration = $pending->data->duration;
			$db->setQuery( "SELECT * FROM #__paidsystem_duration WHERE published = 1 AND (type='both' OR type='new')");
			$durations = $db->loadObjectList("id");
			if (($ad_duration != 0)&&isset($durations)&&count($durations) > 0)
			{
				$duration = $durations[$ad_duration];
				$delta = $duration->duration;
                if(strtotime($pending->data->publication_date) < time()){
                    $pending->data->publication_date = date("Y-m-d H:i:s");
                }
				if ($delta === 0)
					$expiration_date = null;
				else
					$expiration_date = date("Y-m-d H:i:s", strtotime($pending->data->publication_date)+($delta*24*3600));
				$row->expiration_date = $expiration_date;
			}
		}
		$highlight = $content->data['paid']['highlight'];
		if ($highlight != 0) {
			if ($conf->option_mode == "interval") {
				$down = date("Y-m-d 23:59:59",strtotime($content->data['paid']['highlight_down']));	
				$up = date("Y-m-d 00:00:00",strtotime($content->data['paid']['highlight_up']));	
			} else {
				$db->setQuery( "SELECT * FROM #__paidsystem_highlight WHERE id=".(int)$highlight );
				$highlightduration = $db->loadObject();
				if ($highlightduration->duration == 0)
						$down = null;
				else
						$down = date("Y-m-d 23:59:59",time()+$highlightduration->duration*3600*24);
				$up = date("Y-m-d 00:00:00",time());
			}
			$row->highlight = 1;
			$row->highlight_down = $down;
			$row->highlight_up = $up;
		}
		
		$featured = $content->data['paid']['featured'];
		if ($featured != 0) {
			if ($conf->option_mode == "interval") {
				$down = date("Y-m-d 23:59:59",strtotime($content->data['paid']['featured_down']));
				$up = date("Y-m-d 00:00:00",strtotime($content->data['paid']['featured_up']));
			} else {
			$db->setQuery( "SELECT * FROM #__paidsystem_featured WHERE id=".(int)$featured );
			$featuredduration = $db->loadObject();
			if ($featuredduration->duration == 0)
					$down = null;
			else
					$down = date("Y-m-d 23:59:59",time()+$featuredduration->duration*3600*24);
				$up = date("Y-m-d 00:00:00",time());
			}
			$row->featured = 1;
			$row->featured_down = $down;
			$row->featured_up = $up;
		}
		
		$top = $content->data['paid']['top'];
		if ($top != 0) {
			if ($conf->option_mode == "interval") {
				$down = date("Y-m-d 23:59:59",strtotime($content->data['paid']['featured_down']));
				$up = date("Y-m-d 00:00:00",strtotime($content->data['paid']['featured_up']));
			} else {
			$db->setQuery( "SELECT * FROM #__paidsystem_top WHERE id=".(int)$top );
			$topduration = $db->loadObject();
			if ($topduration->duration == 0)
					$down = null;
			else
					$down = date("Y-m-d 23:59:59",time()+$topduration->duration*3600*24);
				$up = date("Y-m-d 00:00:00",time());
			}
			$row->top = 1;
			$row->top_down = $down;
			$row->top_up = $up;
	
			//Pas sur de ca ?? TODO
			$db->setQuery( "UPDATE #__adsmanager_ads SET date_created = NOW() WHERE id=".(int)$contentid);
			$db->execute();
		}
	}
		
    if ($contentid != 0) {
    	$db->setQuery("DELETE FROM #__paidsystem_ads WHERE id = $contentid");
    	$db->execute();	
    }
    
	$ret = $db->insertObject('#__paidsystem_ads', $row);
}

function getMaxPaidSystemImages()
{
	static $max;

	if ($max === null) {
		$db =JFactory::getDbo();
		
		$conf = getPaidSystemConfig();
		
		$query = "SELECT MAX(num_images) FROM #__paidsystem_categories WHERE 1";
		$db->setQuery($query);
		$max = $db->loadResult();
		
		if ($conf->num_images > $max)
			$max = $conf->num_images ;
	}
		
	return $max;
}

function displayPaidCat($nbbasiccats)
{
	$db =JFactory::getDbo();
	$conf = getPaidSystemConfig();
	
	if  ($conf->nbcats > 0)
	{
		if ($conf->credits == 0)
			echo sprintf(JText::_('PAIDSYSTEM_CATPRICE1'),$nbbasiccats,getPrice($conf->cat_price),$conf->nbcats+$nbbasiccats);
		else
			echo sprintf(JText::_('PAIDSYSTEM_CATPRICE2'),$nbbasiccats,getPrice($conf->credits),getPrice($conf->cat_price),$conf->nbcats+$nbbasiccats);
	}
	else
	{
		echo sprintf(JText::_('ADSMANAGER_NBCATS_LEGEND'),$nbbasiccats);
	}
}

function getMaxCats($nbbasiccats)
{
	$conf = getPaidSystemConfig();
	
	return $nbbasiccats + $conf->nbcats;
}

function checkPaidField($field)	
{
	$db =JFactory::getDbo();
	$db->setQuery( "SELECT f.*,p.id,p.price FROM #__adsmanager_fields AS f  ".
						 "LEFT JOIN #__paidsystem_fields as p ON p.id = f.fieldid ".
						 "WHERE 1" );
	$fieldprices = $db->loadObjectList("id");
	if (isset($fieldprices[$field->fieldid])) {
		$price = $fieldprices[$field->fieldid]->price;
		if ($price > 0)
		{
			if (($field->type == "multicheckbox" )||($field->type == "radio"))
			{
				return "<tr><td>".getPrice($price)."</td></tr>";
			}
			else
				return '&nbsp;'.getPrice($price);
		} else {
			return "";
		}
	}
}

function loadEditFormCheck($mode = "front")
{
}

function updatePaidSystemConf(&$conf,$catid)
{
	$db =JFactory::getDbo();
	
	$db->setQuery( "SELECT * FROM #__paidsystem_categories WHERE id = ".(int)$catid );
	$cat = $db->loadObject();
	
	if (isset($cat)&&($cat->specific))
	{
		$conf->credits = $cat->price;	
		$conf->num_images = $cat->num_images;
		$conf->image_price = $cat->image_price;
	}
}

function showPaidDuration($content) {
	$app = JFactory::getApplication();
	
	$date = $content->expiration_date;
	
	if (strtotime($date) < time())
		$date = date('Y-m-d');
	
	$db =JFactory::getDbo();
	$user = JFactory::getUser();
	
	$mode = getPaidSystemMode();
	
	if ($user->id == 0) {	
		TTools::redirectToLogin("index.php?option=com_adsmanager&view=expiration&id=".$content->id);
	}
	
	$catid = $content->catid;

	$db->setQuery( "SELECT * FROM #__paidsystem_duration WHERE published = 1 AND (type = 'both' OR type='renew') AND ( catsid LIKE '%,$catid,%' OR catsid LIKE '%,-1,%') ORDER BY ordering ASC" );
	$durations = $db->loadObjectList("id");
	
	$mode =getPaidSystemMode();
		
	if ($mode == "credits") {
		$balance = getBalance($user->id);
	}
	
	// get configuration
	$query = "SELECT * FROM #__adsmanager_config WHERE 1";
	$db->setQuery($query);
	$conf = $db->loadObject();
	
	$config = getPaidSystemConfig();

	$templateDir = JPATH_ROOT . '/templates/' . $app->getTemplate();
	if (is_file($templateDir.'/html/com_paidsystem/expiration/default.php')) {
		require($templateDir.'/html/com_paidsystem/expiration/default.php');
	} else {
		require(JPATH_ROOT.'/components/com_paidsystem/views/expiration/tmpl/default.php');
	}
}

function renewPaidAd($adid)
{
	$app = JFactory::getApplication();
	$db =JFactory::getDbo();
	$user = JFactory::getUser();
	
	if ($user->id == 0) {
		TTools::redirectToLogin("index.php?option=com_adsmanager&view=expiration&id=$adid");
	}
	
	$db->setQuery( "SELECT * FROM #__paidsystem_duration WHERE published = 1 AND (type = 'both' OR type='renew')  ORDER BY ordering ASC" );
	$durations = $db->loadObjectList("id");
	
	$db->setQuery( "SELECT expiration_date FROM #__adsmanager_ads WHERE id = ".(int)$adid);
	$expiration_date = $db->loadResult();
	$time = strtotime($expiration_date);
	if ($time < time())
	{
		$time = time();
	}
	$current_time = $time;
	
	// get configuration
	$query = "SELECT * FROM #__adsmanager_config WHERE 1";
	$db->setQuery($query);
	$conf = $db->loadObject();
	
	if (count($durations) == 0)
	{
		$time = $time + ( $conf->ad_duration * 3600 *24);
		$newdate = date("Y-m-d",$time);
		
		//Check if needed
		if (time() < strtotime($expiration_date) - ($conf->recall_time * 3600 *24)) {
			$app->enqueueMessage(\JText::_('ADSMANAGER_CONTENT_CANNOT_RESUBMIT'), 'message');
			$app->redirect(TRoute::_("index.php?option=com_adsmanager"),200);
		}
		
		//echo "UPDATE #__adsmanager_ads SET expiration_date = '$newdate', date_created = CURDATE(),recall_mail_sent=0,published=1 WHERE id=".(int)$adid;
		//exit();
		
		try {
			$db->setQuery( "UPDATE #__adsmanager_ads SET expiration_date = '$newdate', date_created = CURDATE(),date_modified = CURDATE(),recall_mail_sent=0,published=1 WHERE id=".(int)$adid);
			$db->execute();
		} catch (Exception $e) {
			echo $e->getMessage();
			return false;
		}
	}
	else
	{
		$mode =getPaidSystemMode();
		
		if ($mode == "credits") {
			$config = getPaidSystemConfig();
			
			$balance = getBalance($user->id);
		
			$input = JFactory::getApplication()->input;
			$durationid = $input->get("ad_duration",-1,'int');
		
			if (!isset($durations[$durationid])) {
				reset($durations);
                $durationid = key($durations);
			} 
			
			if (ADSMANAGER_SPECIAL == "DAN") {
				$db->setQuery( "SELECT images FROM #__adsmanager_ads WHERE id=".(int)$adid );
				$images = $db->loadResult();
				$images = @json_decode($images);
				if (!is_array($images))
					$images = array();
				$nbimages = count($images);
				$nbpaidimages = $nbimages - $conf->nb_images;
				if ($nbpaidimages < 0)
					$nbpaidimages = 0;
			
				$cost = $durations[$durationid]->credits + $config->image_price * $nbpaidimages * ceil($durations[$durationid]->duration/7);
				//var_dump($nbpaidimages);exit();
			} else {
				$cost = $durations[$durationid]->credits;
			}
			
			if ($balance >= $cost) {
				removeCredits($user->id,$cost,"Id = $adid, duration price");	
			
				if ($durations[$durationid]->duration === 0) {
					$newdate = "NULL";
				} else {
					$time = $time + ( $durations[$durationid]->duration * 3600 *24); 
					$newdate = "'".date("Y-m-d",$time)."'";
				}
		
				
				try {
					$db->setQuery( "UPDATE #__adsmanager_ads SET expiration_date = $newdate, date_created = CURDATE(),date_modified = CURDATE(),recall_mail_sent=0,published=1 WHERE id=".(int)$adid);
					$db->execute();
					$cache = JFactory::getCache( 'com_adsmanager');
					$cache->clean();
				} catch (Exception $e) {
					echo $e->getMessage();
					return false;
				}
				return true;
			}
			else {
				$app = JFactory::getApplication();
				$errorMsg= sprintf(\JText::_('PAIDSYSTEM_NOT_ENOUGH_CREDITS'), strtolower(getCurrencySymbol()));
				$app->enqueueMessage($errorMsg, 'message');
				$app->redirect(TLink::getMyAdsLink(), 200);
				return false;
			}
		} else {
			$config = getPaidSystemConfig();
		
			$durationid = $input->get("ad_duration",-1,'int');
			
			if (!isset($durations[$durationid])) {
				reset($durations);
                $durationid = key($durations);
            }
			
			if (ADSMANAGER_SPECIAL == "DAN") {
				$db->setQuery( "SELECT images FROM #__adsmanager_ads WHERE id=".(int)$adid );
				$images = $db->loadResult();
				$images = @json_decode($images);
				if (!is_array($images))
					$images = array();
				$nbimages = count($images);
				$nbpaidimages = $nbimages - $conf->nb_images;
				if ($nbpaidimages < 0)
					$nbpaidimages = 0;
				
				$cost = $durations[$durationid]->credits + $config->image_price * $nbpaidimages * ceil($durations[$durationid]->duration/7);
				
			} else {
				$cost = $durations[$durationid]->credits;
			}
			
			if ($cost == 0) {
				if ($durations[$durationid]->duration === 0) {
					$newdate = "NULL";
				} else {
					$time = $time + ( $durations[$durationid]->duration * 3600 *24); 
					$newdate = "'".date("Y-m-d",$time)."'";
				}
				
				
				try {
					$db->setQuery( "UPDATE #__adsmanager_ads SET expiration_date = $newdate, date_created = CURDATE(),date_modified = CURDATE(),recall_mail_sent=0,published=1 WHERE id=".(int)$adid);
					$db->execute();
				} catch (Exception $e) {
					echo $e->getMessage();
					return false;
				}
				return true;
			} else {	
				$query = "DELETE FROM #__adsmanager_pending_ads WHERE contentid = ".(int)$adid;
				$db->setQuery($query);
				$db->execute();
				
				$row = new JObject();
				$row->contentid = $adid;
				$row->content = json_encode(array('renew_duration' => (int)$durations[$durationid]->duration));
				$row->date = date("Y-m-d H:i:s");
				$row->userid = $user->id;
				$db->insertObject('#__adsmanager_pending_ads', $row);
				$pending_id = (int)$db->insertid();
				
				if(file_exists(JPATH_ROOT.'/components/com_invoicing/lib/core.php')) {
                    include_once(JPATH_ROOT.'/components/com_invoicing/lib/core.php');
                }else{
                    cleanError('You need to install Invoicing.');
                }
				
				$items = array();
				if ($durations[$durationid]->duration === 0) {
					$text = JText::_('PAIDSYSTEM_ORDER_RENEW_UNLIMITED');
				} else {
					$text = sprintf(JText::_('PAIDSYSTEM_ORDER_RENEW'),(int)$durations[$durationid]->duration);
				}
				$items[] = array('quantity'=>1,'tax'=>$config->tax,'name'=>$text,'gross_unit_price'=>$cost,
								 'source'=>'adsmanager-renew');
				
				$invoice_id = Invoicing::createInvoice($user->id, $items, "adsmanager",$adid,
										 $config->currency_id);
				Invoicing::redirectToPayment($invoice_id);
			}
		}
	}
}

function getCategoryOption($cat,&$result) {
	static $catprices = null;
	
	$conf = getPaidSystemConfig();
	
	if ($conf->nbcats == 0)
	{
		if ($catprices == null) {
			$db = JFactory::getDbo();
			$db->setQuery("SELECT * FROM #__paidsystem_categories WHERE 1");
			$catprices = $db->loadObjectList("id");
			foreach($catprices as $key => $notused)
			{
				if ($catprices[$key]->specific == 0)
				{
					$catprices[$key]->price = $conf->credits;
				}
			}
		}
		
		if (!isset($catprices[$cat->id])) {
			$price = 0;
		} else {
			$price = $catprices[$cat->id]->price ;
		}
		$result['attribs']= "price='$price'";
		$result['label'] .= getPrice($price," - ");
	} 
}

function getPaidSystemConfig() {
	static $conf = null;
	if ($conf == null) {
		$db = JFactory::getDbo();
		$query = "SELECT * FROM #__paidsystem_config WHERE 1";
		$db->setQuery($query);
		$conf = $db->loadObject();
		$params = json_decode($conf->params);
		if ($params != null) {
			foreach($params as $name => $value) {
				$conf->$name = $value;
			}
		}
	}
	return $conf;
}

function editPaidAd($row,$isUpdateMode,$adsmanager_conf,$mode = "front")
{
	$db = JFactory::getDbo();
	$user = JFactory::getUser();
	$baseurl = JURI::root();
	
	$conf = getPaidSystemConfig();
	
	if (isset($row->userid)&&($row->userid != 0))
		$userid = $row->userid;
	else
		$userid = $user->id;

	if ($conf->mode == "credits" )
		$balance = getBalance($userid);
	
	if (isset($row->id)) {
		$db->setQuery( "SELECT * FROM #__paidsystem_ads WHERE id=".(int)$row->id );
		$adext = $db->loadObject();
		$ad_id =  $row->id;
	}
	else {
		$adext = null;
		$ad_id = 0;
		$row = new stdClass();
		$row->id = 0;
	}

	$input = JFactory::getApplication()->input;
	
	$default = 0;
	if (($row->id != 0)||($row->id != ""))
		$default = $row->cats[0]->catid; //TODO it was selectedcats ???
	$catid = $input->get("catid",$default,'int');
	
	if ($adsmanager_conf->nbcats + $conf->nbcats == 1)
	{
		updatePaidSystemConf($conf,$catid);
	}

	$db->setQuery( "SELECT f.*,p.id,p.price FROM #__adsmanager_fields AS f  ".
					 "LEFT JOIN #__paidsystem_fields as p ON p.id = f.fieldid ".
					 "WHERE f.published = 1 ORDER by f.ordering" );
	$fieldprices = $db->loadObjectList("id");
	
	$db->setQuery( "SELECT * FROM #__paidsystem_duration WHERE published = 1 AND (type = 'both' OR type='new')  AND ( catsid LIKE '%,$catid,%' OR catsid LIKE '%,-1,%') ORDER BY ordering ASC" );
	$durations = $db->loadObjectList();

    foreach($durations as $duration) {
        $params = json_decode($duration->params);
        if ($params != null) {
            foreach($params as $name => $value) {
                $duration->$name = $value;
            }
        }
    }
    
	$db->setQuery( "SELECT DATEDIFF(expiration_date,date_created) FROM #__adsmanager_ads WHERE id=".(int)$row->id );
	$days = $db->loadResult();
	
    
	if($conf->featured_active == 1){
		$db->setQuery( "SELECT * FROM #__paidsystem_featured WHERE published = 1 ORDER BY ordering ASC " );
		$featureddurations = $db->loadObjectList();
        
        foreach($featureddurations as $featuredduration) {
            $params = json_decode($featuredduration->params);
            if ($params != null) {
                foreach($params as $name => $value) {
                    $featuredduration->$name = $value;
                }
            }
        }
	}
	
	if($conf->highlight_active == 1){
		$db->setQuery( "SELECT * FROM #__paidsystem_highlight WHERE published = 1 ORDER BY ordering ASC" );
		$highlightdurations = $db->loadObjectList();
        
        foreach($highlightdurations as $highlightduration) {
            $params = json_decode($highlightduration->params);
            if ($params != null) {
                foreach($params as $name => $value) {
                    $highlightduration->$name = $value;
                }
            }
        }
	}
	
	if($conf->top_active == 1){
		$db->setQuery( "SELECT * FROM #__paidsystem_top WHERE published = 1 ORDER BY ordering ASC" );
		$topdurations = $db->loadObjectList();
        foreach($topdurations as $topduration) {
            $params = json_decode($topduration->params);
            if ($params != null) {
                foreach($params as $name => $value) {
                    $topduration->$name = $value;
                }
            }
        }
		if ($row->id == 0) {
			foreach($topdurations as $k => $t) {
				if ($t->duration == 1) {
					unset($topdurations[$k]);
				}
			}
		}
	}
	
	$db->setQuery("SELECT * FROM #__paidsystem_ads");
	$list = $db->loadObjectList();
	
/*	$dates = array();
	$ctime = time();
	foreach($list as $item) {
		//Si featured ou si va l'être
		$time = strtotime($item->featured_up);
		if (($item->featured == 1)||($time > $ctime)) {
			$ftime = strtotime($item->featured_down);
			while($time < $ftime) {
				if (!isset($dates[$time])) 
					$dates[$time] = 0;
				$dates[$time]++;
				$time += 3600 * 24;
			}
		}
	}
	$udates = array();
	foreach($dates as $time => $nb) {
		if ($nb >= 1) {
			$udates[] = $time."000";
		}
	}*/
	$app = JFactory::getApplication();
	$templateDir = JPATH_ROOT . '/templates/' . $app->getTemplate();
	if (is_file($templateDir.'/html/com_paidsystem/edit/default.php')) {
		require($templateDir.'/html/com_paidsystem/edit/default.php');
	} else {
		require(JPATH_ROOT.'/components/com_paidsystem/views/edit/tmpl/default.php');
	}
	
	if (is_file($templateDir.'/html/com_paidsystem/edit/javascript.php')) {
		require($templateDir.'/html/com_paidsystem/edit/javascript.php');
	} else {
		require(JPATH_ROOT.'/components/com_paidsystem/views/edit/tmpl/javascript.php');
	}
	?>
	<?php
}

function loadImagesScript($content, $adsmanager_conf) {
	$conf = getPaidSystemConfig();

	if (!isset($conf->enable_image_pack) || $conf->enable_image_pack == 0) {  
		if (($adsmanager_conf->nb_images + $conf->num_images) >= 0) {
						$nbimages = 0;
						$nbMaxCount = (int)$adsmanager_conf->nb_images + (int)$conf->num_images;

						$script = "
								max_total_file_count = ".$nbMaxCount.";
								nb_free_images = ".$adsmanager_conf->nb_images.";
								if (current_uploaded_files_count > nb_free_images) {
										nb_free_images = current_uploaded_files_count;
								}	
								setTotalFileCount(max_total_file_count);";
								
						$html = '';
						if ($adsmanager_conf->nb_images == 0) {
								$html = sprintf(JText::_('ADSMANAGER_IMAGE_PRICE_WITHOUT_FREE_IMAGES'),  getPrice($conf->image_price));
						} elseif($conf->num_images > 0) {
								$html = sprintf(JText::_('ADSMANAGER_IMAGE_PRICE_WITH_FREE_IMAGES'),$adsmanager_conf->nb_images,getPrice($conf->image_price));
						}
		
						$script .= "
						jQ('#uploader_td').prepend(".json_encode($html).");
						current_image_cost = 0; 
						function updatePaidCurrentFileCount(current_nbimages,new_nbimages) {
								image_price = ".(int)$conf->image_price."; //* ad_duration_credits;
								if (new_nbimages >= nb_free_images) {
										price = image_price * (new_nbimages-nb_free_images);
								} else {
										price = 0;
								}
								changeprice = price - current_image_cost;
								current_image_cost = price;
								jQ('#paidsystemadcost').val(parseFloat(jQ('#paidsystemadcost').val()) + changeprice);
						}";
						
						$nbtmpimages = 0;
						if (!empty($content->images)) {
						foreach($content->images as $img) {
								if (isset($img->tmp) && ($img->tmp == 1)) {
										$nbtmpimages++;
								}
						}
						}
						if ($nbtmpimages > 0) {
								$nbimages = count($content->images);
								if (($nbimages-$nbtmpimages) > $adsmanager_conf->nb_images) {
										$free_images = $nbimages-$nbtmpimages;
								} else {
										$free_images = $adsmanager_conf->nb_images;
								}
								if ($nbimages > $free_images) {
										$calcResult = ($nbimages -  $free_images) * $conf->image_price;
										$script .= "jQ(document).ready(function() {
												current_image_cost = ".$calcResult.";
												jQ('#paidsystemadcost').val(parseFloat(jQ('#paidsystemadcost').val()) + current_image_cost);
										});";
								}
						}
				return $script;
			}
		}
		return '';
}

function displayImagePackOption($content,$adext) {
	$conf = TConf::getConfig();
	$paidconfig = getPaidSystemConfig();
	if (isset($paidconfig->enable_image_pack) && $paidconfig->enable_image_pack == 1) {
		$app = JFactory::getApplication();
		$templateDir = JPATH_ROOT . '/templates/' . $app->getTemplate();
	
		if (is_file($templateDir.'/html/com_paidsystem/edit/imagepack.php')) {
			require($templateDir.'/html/com_paidsystem/edit/imagepack.php');
		} else {
			require(JPATH_ROOT.'/components/com_paidsystem/views/edit/tmpl/imagepack.php');
		}
	}
}

function editAdminPaidAd($row,$isUpdateMode,$adsmanager_conf)
{
	$db = JFactory::getDbo();
	$user = JFactory::getUser();
	$baseurl = JURI::root();
	
	$conf = getPaidSystemConfig();
	$input = JFactory::getApplication()->input;
	
	if (isset($row->userid)&&($row->userid != 0))
		$userid = $row->userid;
	else
		$userid = $user->id;
		
	if (isset($row->id)) {
		$db->setQuery( "SELECT * FROM #__paidsystem_ads WHERE id=".(int)$row->id );
		$adext = $db->loadObject();
		$ad_id =  $row->id;
	}
	else {
		$adext = null;
		$ad_id = 0;
		$row = new stdClass();
		$row->id = 0;
	}

	if ($adsmanager_conf->nbcats + $conf->nbcats == 1)
	{
		$default = 0;
		if (($row->id != 0)||($row->id != ""))
			$default = $row->cats[0]->catid; //TODO it was selectedcats ???
		$catid = $input->get("catid",$default,'int');
		updatePaidSystemConf($conf,$catid);
	}
	
	if($conf->featured_active == 1){
		$db->setQuery( "SELECT * FROM #__paidsystem_featured WHERE 1" );
		$featureddurations = $db->loadObjectList();
	}
	
	if($conf->highlight_active == 1){
		$db->setQuery( "SELECT * FROM #__paidsystem_highlight WHERE 1" );
		$highlightdurations = $db->loadObjectList();
	}
	
	if($conf->top_active == 1){
		$db->setQuery( "SELECT * FROM #__paidsystem_top WHERE 1" );
		$topdurations = $db->loadObjectList();
	}
	
	$app = JFactory::getApplication();
	$templateDir = JPATH_ROOT . '/administrator/templates/' . $app->getTemplate();
	if (is_file($templateDir.'/html/com_paidsystem/admin/editcontent.php')) {
		require($templateDir.'/html/com_paidsystem/admin/editcontent.php');
	} else {
		require(JPATH_ROOT.'/administrator/components/com_paidsystem/views/admin/tmpl/editcontent.php');
	}
	?>
	<?php
}

function deletePaidAd($id)
{
	$db =JFactory::getDbo();
	$db->setQuery( "DELETE FROM #__paidsystem_ads WHERE id = ".(int)$id );
	$db->execute();
}

function getContentClass($row,$prefix)
{
	$class = "";
	if (isset($row->highlight) && $row->highlight == 1)
		$class .= " {$prefix}_highlight";
	if (isset($row->featured) && $row->featured == 1)
			$class .= " {$prefix}_featured";
	if (isset($row->top) && $row->top == 1)
		$class .= " {$prefix}_top";
	return $class;
}


function updateQuery(&$query)
{
	$query= str_replace("SELECT ","SELECT adext.*, ",$query); 
	$query= str_replace("SELECT adext.*, DISTINCT","SELECT DISTINCT",$query); 
    $query= str_replace("(SELECT adext.*, ","(SELECT ",$query);

	$query= str_replace("FROM #__adsmanager_ads as a ",
				 "FROM #__adsmanager_ads as a LEFT JOIN #__paidsystem_ads as adext ON a.id = adext.id ",
				 $query); 
}

function updateQueryWithReorder(&$query)
{
	$db =JFactory::getDbo();
	$conf = getPaidSystemConfig();
	
	$query= str_replace("SELECT ","SELECT adext.*, ",$query); 
	$query= str_replace("SELECT adext.*, DISTINCT","SELECT DISTINCT",$query); 
	$query= str_replace("(SELECT adext.*, ","(SELECT ",$query);
	
	/*
	 * "1"=> The ad is brought to the top of the list once daily
	 * "0" = >The ad sticks to the top of the list
	 */
	if ($conf->top_type == 0) {
		$query= str_replace("ORDER BY","ORDER BY adext.top DESC, ",$query); 
	}
	
	$query= str_replace("FROM #__adsmanager_ads as a ",
				 "FROM #__adsmanager_ads as a LEFT JOIN #__paidsystem_ads as adext ON a.id = adext.id ",
				 $query); 
}

function sendOptionExpirationMail($type,$contentid) {
	require_once JPATH_ROOT."/administrator/components/com_adsmanager/models/content.php";
	$confpaidsystem = getPaidSystemConfig();
	
    if($confpaidsystem->mail_on_option_expiration == 1) {
        $subject = $confpaidsystem->mail_expiration_subject;
        $body = $confpaidsystem->mail_expiration_body;

        // get configuration
        $db = JFactory::getDbo();
        $query = "SELECT * FROM #__adsmanager_config WHERE 1";
        $db->setQuery($query);
        $conf = $db->loadObject();

        $model = AdsmanagerModelContent::getInstance('content','AdsmanagerModel');
        $content = $model->getContent($contentid,false);
        $user = JFactory::getUser($content->userid);

        switch($type) {
            case "highlight": $typename = JText::_('PAIDSYSTEM_HIGHLIGHT');break;
            case "featured": $typename = JText::_('PAIDSYSTEM_FEATURED');break;
            case "top": $typename = JText::_('PAIDSYSTEM_TOP');break;
        }

        //TODO add tag in the help context of paidsystem configuration
        $subject = str_replace("{option}",$typename,$subject);
        $body = str_replace("{option}",$typename,$body);

        /*$uri	= JURI::getInstance();
        $root	= $uri->toString( array('scheme', 'host', 'port'));
        $link = $root.TRoute::_("index.php?option=com_adsmanager&view=details&catid=".$content->catid."&id=".$content->id,false);
        $link = str_replace("administrator/","",$link);
        $body = str_replace('{link}',$link,$body);*/


        $model->sendMailToUser($subject,$body,$user,$content,$conf,"option_expiration");
    }
}

function managePaidOption() {
	$db =JFactory::getDbo();
	$conf = getPaidSystemConfig();
	//Todo JDate
	$date = date("Y-m-d H:i:s",time());
	
	if ($conf->highlight_active==1) {
		$query = "SELECT id FROM #__paidsystem_ads WHERE highlight_down < '$date' AND highlight = 1";
		$db->setQuery($query);
		$ads = $db->loadObjectList();
		foreach($ads as $ad) {
			sendOptionExpirationMail("highlight",$ad->id);
			$db->setQuery("UPDATE #__paidsystem_ads SET highlight = 0 WHERE id = ".$ad->id);
			$db->execute();
		}
        $query = "SELECT id FROM #__paidsystem_ads 
                  WHERE highlight = 0
                  AND highlight_down >= '$date' 
                  AND highlight_up <= '$date' 
                  AND highlight_down IS NOT NULL
                  AND highlight_up IS NOT NULL";
		$db->setQuery($query);
		$ads = $db->loadObjectList();
		foreach($ads as $ad) {
			$db->setQuery("UPDATE #__paidsystem_ads SET highlight = 1 WHERE id = ".$ad->id);
			$db->execute();
		}
	}
	
	if ($conf->featured_active==1) {
		$query = "SELECT id FROM #__paidsystem_ads WHERE featured_down < '$date' AND featured = 1";
		$db->setQuery($query);
		//echo $query;
		$ads = $db->loadObjectList();
		foreach($ads as $ad) {
			sendOptionExpirationMail("featured",$ad->id);
			$db->setQuery("UPDATE #__paidsystem_ads SET featured = 0 WHERE id = ".$ad->id);
			$db->execute();
		}
        $query = "SELECT id FROM #__paidsystem_ads 
                  WHERE featured = 0
                  AND featured_down >= '$date' 
                  AND featured_up <= '$date' 
                  AND featured_down IS NOT NULL
                  AND featured_up IS NOT NULL";
		$db->setQuery($query);
		$ads = $db->loadObjectList();
		foreach($ads as $ad) {
			$db->setQuery("UPDATE #__paidsystem_ads SET featured = 1 WHERE id = ".$ad->id);
			$db->execute();
		}
	}
	
	if ($conf->top_active==1) {
		if ($conf->top_type != 0) {
			$nbdays = 1;
			$query = "SELECT p.id,a.date_created FROM #__paidsystem_ads as p INNER JOIN #__adsmanager_ads AS a ON a.id = p.id WHERE top=1";
			$db->setQuery($query);
			$ads = $db->loadObjectList();
			
			foreach($ads as $ad) {
				$ad_time = strtotime($ad->date_created);
				
				if ((time()-$ad_time) >= ($nbdays*3600*24)) {
					$db->setQuery("UPDATE #__adsmanager_ads SET date_created = NOW(),date_modified = NOW() WHERE id = ".$ad->id);
					$db->execute();
					//echo "UPDATE #__adsmanager_ads SET date_created = NOW() WHERE id = ".$ad->id;
                    if(isset($conf->mail_on_notification_top) && $conf->mail_on_notification_top == 1) {
                        sendNotificationTop($ad->id);
                    }
                }
			}
		}
		$query = "SELECT id FROM #__paidsystem_ads WHERE top_down < '$date' AND top = 1";
		$db->setQuery($query);
		$ads = $db->loadObjectList();
		foreach($ads as $ad) {
			sendOptionExpirationMail("top",$ad->id);
			$db->setQuery("UPDATE #__paidsystem_ads SET top = 0 WHERE id = ".$ad->id);
			$db->execute();
		}
        $query = "SELECT id FROM #__paidsystem_ads 
                  WHERE top = 0
                  AND top_down >= '$date' 
                  AND top_up <= '$date' 
                  AND top_down IS NOT NULL
                  AND top_up IS NOT NULL";
		$db->setQuery($query);
		$ads = $db->loadObjectList();
		foreach($ads as $ad) {
			$db->setQuery("UPDATE #__paidsystem_ads SET top = 1 WHERE id = ".$ad->id);
			$db->execute();
		}
	}
}

function sendNotificationTop($contentid) {
    require_once JPATH_ROOT."/administrator/components/com_adsmanager/models/content.php";
	$confpaidsystem = getPaidSystemConfig();
	
	$subject = $confpaidsystem->mail_notification_top_subject;
	$body = $confpaidsystem->mail_notification_top_body;
	
	// get configuration
	$db = JFactory::getDbo();
	$query = "SELECT * FROM #__adsmanager_config WHERE 1";
	$db->setQuery($query);
	$conf = $db->loadObject();
	
	$model = AdsmanagerModelContent::getInstance('content','AdsmanagerModel');
	$content = $model->getContent($contentid,false);
	$user = JFactory::getUser($content->userid);
	
	/*$uri	= JURI::getInstance();
	$root	= $uri->toString( array('scheme', 'host', 'port'));
	$link = $root.TRoute::_("index.php?option=com_adsmanager&view=details&catid=".$content->catid."&id=".$content->id,false);
	$link = str_replace("administrator/","",$link);
	$body = str_replace('{link}',$link,$body);*/
	
	
	$model->sendMailToUser($subject,$body,$user,$content,$conf,"notification_top");
}

function getPaidSystemMode() {
	$conf = getPaidSystemConfig();
	return $conf->mode;
}

function _save_log($output) {
	$filename = "components/com_paidsystem/log.txt";
	$fd = fopen($filename,"a");
	$output .= "\r\n";
	fwrite($fd, date("Ymd G:i:s")." -> ".$output);
	fclose ($fd);
}

/**
 * generate Bill
 * @param ad $content
 * @param array $items
 * @param int $pending_id the ad id, not the pending_ad_id
 * @return number
 */
function generateBill($content,$items,$pending_id=0) {

	$config = getPaidSystemConfig();

	$db = JFactory::getDbo();	
	$query = "SELECT * FROM #__users WHERE id=".$content->userid;
	$db->setQuery($query);
	$user = $db->loadObject();
	
	if(file_exists(JPATH_ROOT.'/components/com_invoicing/lib/core.php')) {
        include_once(JPATH_ROOT.'/components/com_invoicing/lib/core.php');
    }else{
        cleanError('You need to install Invoicing.');
    }
	
	$invoice_id = Invoicing::createInvoice($user->id, $items, "adsmanager",$pending_id,$config->currency_id);
	return $invoice_id;
}
	
function computeCost(&$total,&$items,$content,$adsmanager_conf,$isUpdateMode) {
	$db = JFactory::getDbo();
	$input = JFactory::getApplication()->input;
	
    if($content->new_ad) {
        $isUpdateMode = 0;
    }
    
	$total = 0;
	$items = array();
	
	$data = $content->getData();
	
	$conf = getPaidSystemConfig();
	
    $user = JFactory::getUser();
    
    if(version_compare(JVERSION, '1.6', 'ge')) {
        if(isset($conf->usergroups_freeads)) {
	        $authorisedUserGroups = JHTMLAdsmanagerUserGroups::getUserGroup($user->id);
	
	        foreach($authorisedUserGroups as $authorisedUserGroup){
	            if(array_search($authorisedUserGroup, $conf->usergroups_freeads) !== false){
	                if($conf->categories_freeads == 1)
	                    return;
	            }
	        }
	    }
    }
    
	if ($adsmanager_conf->nbcats + $conf->nbcats == 1)
	{
		$catid = $data['categories'][0];
		updatePaidSystemConf($conf,$catid);
	}
	
	$percenttax = ((100+$conf->tax)/100);
	
	if ($adsmanager_conf->nbcats + $conf->nbcats == 1)
	{
			if ($isUpdateMode == 0)
			{
				$total += $conf->credits;
				if ($conf->credits > 0) {
					$items[] = array('quantity'=>1,'tax'=>$conf->tax,'name' =>JText::_('PAIDSYSTEM_ORDER_CATEGORY'),'gross_unit_price' => $conf->credits,'source'=>'adsmanager-categories');
				}
			}
	}
	else if ($conf->nbcats > 0)
	{
		$newcats = $data['categories'];
		if ($isUpdateMode == 0)
			$prevcats = array();
		else {
					$query = "SELECT catid FROM #__adsmanager_adcat WHERE adid = ".$content->id;
					$db->setQuery($query);
					$cats = $db->loadObjectList();
					$prevcats = array();
					foreach($cats as $cat) {
						$prevcats[] = $cat->catid;	
					}
		}
		
		$prevnbcats = count($prevcats);
		$newnbcats = count($newcats);
		
		if ($newnbcats > $prevnbcats)
		{
			if ($newnbcats < $adsmanager_conf->nbcats)
			{
				$nbbasiccat = $newnbcats - $prevnbcats;
				$nbaddcat = 0;
			}
			else if ($prevnbcats < $adsmanager_conf->nbcats)
			{
				$nbaddcat = $newnbcats - $adsmanager_conf->nbcats;
				$nbbasiccat = $adsmanager_conf->nbcats - $prevnbcats;
			}
			else
			{
				$nbaddcat = $newnbcats - $prevnbcats;
				$nbbasiccat = 0;
			}
		
			$total += $nbbasiccat * $conf->credits + $nbaddcat * $conf->cat_price;
			
			$text = JText::_('PAIDSYSTEM_ORDER_FIRST_CATEGORIES');
			$items[] = array('quantity'=>$nbbasiccat,'tax'=>$conf->tax,'name' => $text,'gross_unit_price' => $conf->credits,'source'=>'adsmanager-categories');
			if ($nbaddcat > 0) {
				$text = JText::_('PAIDSYSTEM_ORDER_NEXT_CATEGORIES');
				$items[] = array('quantity'=>$nbaddcat,'tax'=>$conf->tax,'name' => $text,'gross_unit_price' => $conf->cat_price,'source'=>'adsmanager-categories');	
			}
		}
	}
	else
	{
		$newcats = $data['categories'];
		if ($isUpdateMode == 0)
			$prevcats = array();
		else {
			$query = "SELECT catid FROM #__adsmanager_adcat WHERE adid = ".$content->id;
			$db->setQuery($query);
			$cats = $db->loadObjectList();
			$prevcats = array();
			foreach($cats as $cat) {
				$prevcats[] = $cat->catid;	
			}
		}
		
		$prevtotal = 0;
		if (count($prevcats) > 0)
		{
			$listcats = implode(',', $prevcats);
			$db->setQuery( "SELECT `specific`,`price` FROM #__paidsystem_categories WHERE id IN ($listcats)");
			$cats = $db->loadObjectList();
			if (isset($cats))
				foreach($cats as $cat)
				{
					if ($cat->specific == 1)
						$prevtotal += $cat->price;
					else
						$prevtotal += $conf->credits;
				}
		}
		
    $listcats = implode(',', $newcats);
    $newtotal = 0;

    if ($listcats != "") {
      $db->setQuery(  " SELECT `specific`,`price` FROM #__adsmanager_categories as a"
              ." LEFT JOIN #__paidsystem_categories as p ON p.id = a.id WHERE a.id IN ($listcats)");
      $cats = $db->loadObjectList();
      
      if (isset($cats)) {
        foreach($cats as $cat)
        {
          if ($cat->specific == 1)
            $newtotal += $cat->price;
          else
            $newtotal += $conf->credits;
        }
      }
    }
		
		$cost = $newtotal - $prevtotal;
		if ($cost > 0)
		{
			$total += $cost;
			$text = JText::_('PAIDSYSTEM_ORDER_CATEGORIES');
			$items[] = array('quantity'=>1,'tax'=>$conf->tax,'name' => $text,'gross_unit_price' => $cost,'source'=>'adsmanager-categories');
		}
	}
	
	$duration_days = 0;
	if ($isUpdateMode == 0)
	{
		$db->setQuery( "SELECT * FROM #__paidsystem_duration WHERE published = 1 AND (type='both' OR type='new')");
		$durations = $db->loadObjectList("id");
		if (isset($durations)&&count($durations) > 0)
		{
			$ad_duration = $input->get("ad_duration" ,0,'int');
			if ($ad_duration != 0) {
				$duration = $durations[$ad_duration];
				$delta = $duration->duration; 
				$duration_days = $delta;
				//Replace === by == because string '0'
				if ($delta == 0) {
					$expiration_date = null;
					$text = JText::_('PAIDSYSTEM_ORDER_EXPIRATION_UNLIMITED');
				
				} else {
					$expiration_date = date("Y-m-d",time()+($delta*24*3600)); 
					$text = sprintf(JText::_('PAIDSYSTEM_ORDER_EXPIRATION'),$expiration_date,$duration->duration);	
				}
				$total += $duration->credits;
				$items[] = array('quantity'=>1,'tax'=>$conf->tax,'name' => $text,'gross_unit_price' => $duration->credits,'source'=>'adsmanager-duration');
			}
		}
	}
	
	if ($conf->featured_active == 1)
	{
		if ($data['paid']['featured'] != 0)
		{
			if ($conf->option_mode == "interval") {
				$duration = $data['paid']['featured_duration'];
				$price = $duration * $conf->featured_price_per_day;
			} else {
			$db->setQuery( "SELECT * FROM #__paidsystem_featured WHERE id=".(int)$data['paid']['featured'] );
				$option = $db->loadObject();
				$duration = $option->duration;
				$price = $option->credits;
			}
			
			if ($price > 0) {
				$total += $price;
				$items[] = array('quantity'=>1,'tax'=>$conf->tax,'name' => sprintf(JText::_('PAIDSYSTEM_ORDER_ITEM_OPTION'),JText::_('PAIDSYSTEM_FEATURED'), $duration),'gross_unit_price' => $price,'source'=>'adsmanager-featured');
			}
		}
	}
	if ($conf->highlight_active == 1)
	{
		if ($data['paid']['highlight'] != 0)
		{
			if ($conf->option_mode == "interval") {
				$duration = $data['paid']['highlight_duration'];
				$price = $duration * $conf->highlight_price_per_day;
			} else {
			$db->setQuery( "SELECT * FROM #__paidsystem_highlight WHERE id=".(int)$data['paid']['highlight'] );
				$option = $db->loadObject();
				$duration = $option->duration;
				$price = $option->credits;
			}
			
			if ($price > 0) {
				$total += $price;
				$items[] = array('quantity'=>1,'tax'=>$conf->tax,'name' => sprintf(JText::_('PAIDSYSTEM_ORDER_ITEM_OPTION'),JText::_('PAIDSYSTEM_HIGHLIGHT'), $duration),'gross_unit_price' => $price,'source'=>'adsmanager-highlight');
			}
		}
	}
	if ($conf->top_active == 1)
	{
		if ($data['paid']['top'] != 0)
		{
			if ($conf->option_mode == "interval") {
				$duration = $data['paid']['top_duration'];
				$price = $duration * $conf->top_price_per_day;
			} else {
				$db->setQuery( "SELECT * FROM #__paidsystem_top WHERE id=".(int)$data['paid']['top'] );
				$option = $db->loadObject();
				$duration = $option->duration;
				$price = $option->credits;
			}
			if ($price > 0) {
				$total += $price;
				$items[] = array('quantity'=>1,'tax'=>$conf->tax,'name' => sprintf(JText::_('PAIDSYSTEM_ORDER_ITEM_OPTION'),JText::_('PAIDSYSTEM_TOP'), $duration),'gross_unit_price' => $price,'source'=>'adsmanager-top');
			}
		}
	}
			
    if (isset($conf->enable_image_pack) && $conf->enable_image_pack == 1)
	{
		if ($data['paid']['images_pack'] != 0)
		{
			if (isset($content->id)) {
				$db->setQuery("SELECT * FROM #__paidsystem_ads WHERE id=".(int)$content->id." and images = 1");
				$adext= $db->loadObject();
			}
			
			if (isset($adext)) {
				//Nothing to do
			} else {
                $nbImagesPack = $conf->num_images;
                $packPrice = $conf->image_price;
                $text = sprintf(JText::_('PAIDSYSTEM_IMAGE_PACK_DESCRIPTION'));
                
				$total += $packPrice;
                $items[] = array('quantity'=>1,'tax'=>$conf->tax,'name' => $text,'gross_unit_price' => $packPrice,'source'=>'adsmanager-image-pack');
			}
		}
	} else {
		$freeimages = $adsmanager_conf->nb_images;
		
		if (isset($content->images)&&is_string($content->images)) {
			$nbcurrentimages = count(json_decode($content->images));
		} 
		else if (isset($content->images)&& is_array($content->images)) {
			$nbcurrentimages = count($content->images);
		} else {
			$nbcurrentimages = 0;
		}
		
		
		if ($nbcurrentimages > $adsmanager_conf->nb_images) {
			$freeimages = 0;
		} else {
			$freeimages = $adsmanager_conf->nb_images - $nbcurrentimages;
		}
		
		$nbnewimages = count(@$data['images']) - $freeimages;

		if ($nbnewimages > 0) {
			$price = $nbnewimages * $conf->image_price;
			$total += $price;
			$text = JText::_('PAIDSYSTEM_ORDER_IMAGES');
			$items[] = array('quantity'=>$nbnewimages,'tax'=>$conf->tax,'name' => $text,'gross_unit_price' => $conf->image_price,'source'=>'adsmanager-images');
		}
	}
		
	$db->setQuery( "SELECT f.*,p.id,p.price FROM #__adsmanager_fields AS f  ".
						"LEFT JOIN #__paidsystem_fields as p ON p.id = f.fieldid ".
						"WHERE f.published = 1 and p.price > 0 ORDER by f.ordering" );
	$fields = $db->loadObjectList("id");
	
	if ($isUpdateMode == 1)
	{
		$db->setQuery( "SELECT * FROM #__adsmanager_ads WHERE id = ".(int)$content->id );
		$current = $db->loadObject();
	}
	
	if(isset($fields))
	{
		foreach($fields as $field)
		{ 	
			if ($content->id != 0)
			{
				$current = $content->current;
				$fieldtitle = $field->name;
				$testvalue = $current->$fieldtitle;
			}	
			else
				$testvalue = "";
				
			if (($testvalue == "")||($testvalue == ",,"))
			{
				if (($field->type == "multiselect")||
					($field->type == "multicheckbox")||
					($field->type == "multicheckboximage"))
				{	
					$value = $data['fields'][$field->name];
					if (count($value) > 0)
					{
						$total += $field->price;
						$text = sprintf(JText::_('PAIDSYSTEM_ORDER_FIELD'),$field->name);
						$items[] = array('quantity'=>1,'tax'=>$conf->tax,'name' => $text,'gross_unit_price' => $field->price,'source'=>'adsmanager-fields');
					}
				}
				else
				{
					$value = $data['fields'][$field->name];
					if ($value != "")
					{
						$total += $field->price;
						$text = sprintf(JText::_('PAIDSYSTEM_ORDER_FIELD'),$field->name);
						$items[] = array('quantity'=>1,'tax'=>$conf->tax,'name' => $text,'gross_unit_price' => $field->price,'source'=>'adsmanager-fields');
					}	
				}
			}
		}
	}
}

function bindPaidSystemContent(&$content,$post,$files,$adsmanager_conf,$model) {
	$db = JFactory::getDbo();
	
	$conf = getPaidSystemConfig();
	$input = JFactory::getApplication()->input;
	
	$content->data['paid'] = array();
	$featured= $input->get("featured",0,'int' );
	$highlight= $input->get("highlight",0,'int' );
	$top= $input->get("top",0,'int' );
	$content->data['paid']['featured'] = $featured;
	$content->data['paid']['highlight'] = $highlight;
	$content->data['paid']['top'] = $top;
	
	if ($conf->option_mode == "interval") {
		$featured_down= $input->get("featured_down","",'String' );
		$highlight_down= $input->get("highlight_down","",'String' );
		$top_down= $input->get("top_down","",'String' );
		$featured_up= $input->get("featured_up","",'String' );
		$highlight_up= $input->get("highlight_up","",'String' );
		$top_up= $input->get("top_up","",'String' );
		
		$content->data['paid']['featured_down'] = $featured_down;
		$content->data['paid']['highlight_down'] = $highlight_down;
		$content->data['paid']['top_down'] = $top_down;
		$content->data['paid']['featured_up'] = $featured_up;
		$content->data['paid']['highlight_up'] = $highlight_up;
		$content->data['paid']['top_up'] = $top_up;

		if ($content->data['paid']['featured'] == 1) {
			$duration = (int) (strtotime($content->data['paid']['featured_down']) - strtotime($content->data['paid']['featured_up']))/(3600*24) +1;
			if (($duration < 0)||($duration > $conf->featured_max_days)) {
				$content->data['paid']['featured'] = 0;
			}
			$content->data['paid']['featured_duration']= $duration;
		}
		if ($content->data['paid']['top'] == 1) {
			$duration = (int) (strtotime($content->data['paid']['top_down']) - strtotime($content->data['paid']['top_up']))/(3600*24)+1;
			if (($duration < 0)||($duration > $conf->top_max_days)) {
				$content->data['paid']['top'] = 0;
			}
			$content->data['paid']['top_duration']= $duration;
		}
		if ($content->data['paid']['highlight'] == 1) {
			$duration = (int) (strtotime($content->data['paid']['highlight_down']) - strtotime($content->data['paid']['highlight_up']))/(3600*24) +1;
			if (($duration < 0)||($duration > $conf->highlight_max_days)) {
				$content->data['paid']['highlight'] = 0;
			}
			$content->data['paid']['highlight_duration']= $duration;
		}
    }
		
    $images_pack = $input->get("images_pack",0,'int' );
    $content->data['paid']['images_pack'] = $images_pack;
	$app = JFactory::getApplication();
	if ($app->isClient('administrator') == true) {	
		$featured_down= $input->get("featured_down","",'String' );
		$highlight_down= $input->get("highlight_down","",'String' );
		$top_down= $input->get("top_down","",'String' );
       	$featured_up= $input->get("featured_up","",'String' );
		$highlight_up= $input->get("highlight_up","",'String' );
		$top_up= $input->get("top_up","",'String' );
		$content->data['paid']['featured_down'] = $featured_down;
		$content->data['paid']['highlight_down'] = $highlight_down;
		$content->data['paid']['top_down'] = $top_down;
       	$content->data['paid']['featured_up'] = $featured_up;
		$content->data['paid']['highlight_up'] = $highlight_up;
		$content->data['paid']['top_up'] = $top_up;	
	}
	
	//if ($content->id == 0) {
		$ad_duration = $input->get("ad_duration" ,0,'int');
		$db->setQuery( "SELECT * FROM #__paidsystem_duration WHERE published = 1 AND (type='both' OR type='new')");
		$durations = $db->loadObjectList("id");
		
		if (($ad_duration != 0)&&isset($durations)&&count($durations) > 0)
		{
			$duration = $durations[$ad_duration];
			$delta = $duration->duration; 
			//Replace === by == because string '0'
			if ($delta == 0)
				$expiration_date = null;
            else
                $expiration_date = date("Y-m-d H:i:s",strtotime($content->publication_date)+($delta*24*3600)); 
            
			$content->expiration_date = $expiration_date;
			$content->data['duration'] = $ad_duration;
		}
	//}
}

function checkAuthorisedNumberAds($contentModel, $category)
{
    include_once(JPATH_ADMINISTRATOR.'/components/com_adsmanager/models/category.php');
    
    if($category == 0)
        return false;
        
    $conf = getPaidSystemConfig();
    $user = JFactory::getUser();
    
    if(version_compare(JVERSION, '1.6', 'ge')) {
		if (isset($conf->usergroups_nolimit) && !empty($conf->usergroups_nolimit)) {
	        $authorisedUserGroups = JHTMLAdsmanagerUserGroups::getUserGroup($user->id);
	
	        foreach($authorisedUserGroups as $authorisedUserGroup){
	            if(array_search($authorisedUserGroup, $conf->usergroups_nolimit) !== false){
	                if($conf->categories_nolimit == 1)
	                    return true;
	            }
	        }
		}
    }
    
    $nb = $contentModel->getNbContentsOfUser($user->id, $category);
    
    //TODO : check authorised number for multi-categories
    $categoriesModel = new AdsmanagerModelCategory();
    
    $category = $categoriesModel->getCategory($category);
    
    if (($category->limitads == -1)||($category->limitads == 0))
        return true;
        
    if($nb >= $category->limitads){
        return $category->limitads;
    }
    
    return true;
}

/**
* Return if a user can see the paid option
* 
* @return boolean
*/
function checkRightOption($option){
   
    //If no usergroup selected, whe allow the option to everyone
    if((!isset($option->acl) || $option->acl == null))
        return true;
    
    $user = JFactory::getUser();
    $userGroups = array();

    //If the user is a guest, we authorise the public group
    //else we return the authorised group of the user
    if($user->guest)
        $userGroups[] = 1;
    else
        $userGroups = JHTMLAdsmanagerUserGroups::getUserGroup($user->id);
    
    $showOption = false;
    $allowedGroupsOptions = explode(',', $option->acl);
    
    foreach ($userGroups as $userGroup) {
        if(array_search($userGroup, $allowedGroupsOptions) !== false){
            $showOption = true;
        }
    }
    
   return $showOption;
}

function countRenewDurations() {
    $db = JFactory::getDbo();
    
    $db->setQuery( "SELECT COUNT(*) FROM #__paidsystem_duration WHERE published = 1 AND (type = 'both' OR type='renew')" );
	$durations = $db->loadResult();
    
    return $durations;
}

function cleanError($errorMsg = '') {
    while(ob_get_clean());
    echo $errorMsg;
    exit();
}

// Merge the language overrides
$paths = array(JPATH_ADMINISTRATOR, JPATH_ROOT);
$jlang = JFactory::getLanguage();
$jlang->load("com_paidsystem", $paths[0], 'en-GB', true);
$jlang->load("com_paidsystem", $paths[0], null, true);
$jlang->load("com_paidsystem", $paths[1], 'en-GB', true);
$jlang->load("com_paidsystem", $paths[1], null, true);
